
hertz	equ	not 6250	; set for 160 hz with 12 mHz clock
tps	equ	160		; ticks per second

rtcisr:
	ipl_synch			; save psw & sfr's
;==============================
	mov	a,tl0			; get cpu delay
	add	a,#low hertz+6		; 1 rate + lag to setup
	mov	tl0,a			; 1
	clr	a			; 1
	addc	a,#high hertz		; 1
	mov	th0,a			; 1
	setb	tr0			; 1 start timer again
	;
	mov	dptr,#count
	movx	a,@dptr
	dec	a		; decrement second counter
	movx	@dptr,a
	jnz	rtckrnl
	mov	a,#tps		; 1/160 ticks per second
	movx	@dptr,a		; 1 second has elapsed
	call	clock		; do every second
	cpl	runlite
rtckrnl:
	if(a2ddvr=1)
	call	a2disr		; A/D sample
	endif

	if(kpdvr=1)
	call	kpisr
	endif
;================================
kernal_exit:
	pop	dph
	pop	dpl
	pop	b
	pop	acc
	pop	psw
	setb	ea
	reti
;
dectim:	movx	a,@dptr
	add	a,#1		; time part
	da	a		; make BCD for display
	cjne	a,b,timok
	clr	a
timok:	movx	@dptr,a
	inc	dptr
	ret
;
clkisr:	mov	dptr,#second
	mov	b,#60h
	call	dectim		; seconds
	jnz	clkdun
	mov	b,#60h
	call	dectim		; minutes
	jnz	clkdun
	mov	b,#24h
	call	dectim		; hours
	jnz	clkdun
	mov	b,#30h
	call	dectim		; days
clkdun:	ret

$include(shotim.asm)
	xseg
second:	ds	1
minute:	ds	1
hour:	ds	1
day:	ds	1
count:	ds	1		; 160
impure	equ $
;================================
	cseg
initrtc:
	anl	tcon,#0cfh	; 
	anl	tmod,#0f0h	; clear timer 0
	orl	tmod,#01h	; mode 1
	if(queue=1)
	  call	inque		; initialize queue
	  jc	irtc3
	  setb	havque
irtc3:
	endif
	clr	a
	mov	dptr,#second
	mov	b,#4
	clr	a
clrtim:	movx	@dptr,a		; reset clock
	inc	dptr
	djnz	b,clrtim
noclrc:	mov	dptr,#count	; point to count
	mov	a,#tps
	movx	@dptr,a		; a second

	setb	pt0		; high priority timer 0
	mov	tl0,#low hertz
	mov	th0,#high hertz
	setb	tr0		; start timer
	orl	ie,#82h
	lcall	ilprt
	db	'RTC activated.',cr,lf,0
	setb	timrun		; tell others it's alive
	ret

