; ----------------------------------------------------
; Counter1.asm      Last Update:10/27/91
;
; Simple Counter Example
; Uses Counter/Timer 0 in Mode 0 or 1
;
; ----------------------------------------------
; system calls              registers used
; ----------------------------------------------

 break     equ  010ch  ; a, (reads accumulator)
 chkbrk    equ  010fh  ; a, (reads serial port)
 crlf      equ  0115h  ; a
 display   equ  011bh  ; a
 inkey     equ  012ah  ; a
 print     equ  0136h  ; a, dptr
 prthex    equ  013fh  ; a, r2

; ====================================================
;       m a i n    p r o g r a m
; UIOD connections
;
; LOW DIGIT    P4     : output (segment a to P4.0, ...
;                               segment g to P4.6)
; PB0          P3.4 (T0) : counter input
; ----------------------------------------------------

      org   8000h         ; run using the monitor
                          ;  G8000 command
      setb  T0            ; prepare T0 for input
; --- use only one of the following instructions. --------
; --- i.e., counter in  either mode 0 or mode 1 ----------
;      mov   TMOD, #84h    ; configure timer/counter 0
;                          ;  counter in mode 0
      mov   TMOD, #85h    ; configure timer/counter 0
                          ;  counter in mode 1
; --------------------------------------------------------
      setb  TR0           ; turn timer/counter 0 on
      mov   b, #0         ; current count

      mov   a, b          ; load a with current count
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit
      mov   a, b          ; get current count
      lcall prthex        ; echo count to host
      lcall crlf          ; new line on host

loop:
      lcall inkey         ; check serial port for character
      lcall break         ; see if character is CTL-C
                          ; terminate program if CTL-C
      mov   a, TL0        ; get counter value
      anl   a, #0fh       ; modulus 0Fh
      xrl   a, b          ; compare with current count
      jz    loop          ; repeat if equal

      inc   b             ; else increment current count
      anl   b, #0Fh       ; modulus 0Fh
      mov   a, b          ; load a with current count
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit
      mov   a, b          ; get current count
      lcall prthex        ; echo count to host
      lcall crlf          ; new line on host

      sjmp loop           ; repeat forever...

; ====================================================
; end of program
