; ----------------------------------------------------
; DAC0.asm    Last Update:10/27/91
;
; Simple Digital-to-Analog Converter Example
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; UIOD Connections:
;  Port 4 to the Digital-to-Analog Converter
;  Port 5 bits:
;   P5.0 to DAC WR1\  (DAC0832 pin  2)
;   P5.1 to DAC WR2\  (DAC0832 pin 18)
;
    DACdata equ 0E8h  ; P4
    WR1     equ 0F8h  ; P5.0
    WR2     equ 0F9h  ; P5.1
; ----------------------------------------------------
;
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 ascbin    equ  0100h  ; a, r2, error flag
 crlf      equ  0115h  ; a
 getchr    equ  0121h  ; a
 os_return equ  0130h
 print     equ  0136h  ; a, dptr
 prthex    equ  013fh  ; a, r2
;bits
 errorf    equ     3   ; monitor error flag
; ----------------------------------------------------

    org 8000h

    mov   DACdata, #0  ; start with 0 volts
    lcall DAC
begin:
    lcall print        ; prompt for input
    db    "input value :  ",0
    lcall getchr       ; input hex digit
    lcall ascbin       ; convert to hex
    jb    errorf, done ; quit if not a hex number
    swap  a            ; multiply by 16
    mov   DACdata, a   ; send to DAC data input
    lcall prthex       ; echo to host screen
    lcall crlf         ; new line
    lcall DAC          ; convert to analog
    sjmp  begin        ; repeat forever...
done:
    lcall print
    db    "program terminates",0
    ljmp os_return     ; return to monitor
; ====================================================
;  subroutine DAC - digital-to-analog conversion
;  input    : none
;  output   : uses WR1 and WR2 to execute a DAC.
;              DAC WR1\  (DAC0832 pin  2)
;              DAC WR2\  (DAC0832 pin 18)
;
;  destroys : Port bits connected to WR1 and WR2
; ----------------------------------------------------
DAC:
        setb  WR1   ; disable DAC
        setb  WR2   ; disable DAC
        clr   WR1   ; input latch
        setb  WR1   ;
        clr   WR2   ; output latch
        setb  WR2   ;
        ret

; ====================================================
;
; end of program
