; ----------------------------------------------------
; DAC1.asm    Last Update:10/27/91
;
; Simple Digital-to-Analog Converter Example
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; UIOD Connections:
;  Port 4 to the Digital-to-Analog Converter
;  Port 5 bits:
;   P5.0 to DAC CS\   (DAC0832 pin 1)
;   P5.1 to DAC WR\   (DAC0832 pins 2 and 18)
;   P5.2 to DAC ILE   (DAC0832 pin 19)
;   P5.3 to DAC XFER\ (DAC0832 pin 17)
;
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 crlf      equ  0115h  ; a
 getbyt    equ  011eh  ; a, b
 print     equ  0136h  ; a, dptr
 prthex    equ  013fh  ; a, r2
; ----------------------------------------------------

    org 8000h

    mov   p4, #0       ; start with 0 volts
    lcall DAC
begin:
    lcall print        ; prompt for input
    db    "input value :  ",0
    lcall getbyt       ; input byte
    mov   p4, a        ; send to DAC data input
    lcall prthex       ; echo to host screen
    lcall crlf         ; new line
    lcall DAC          ; convert to analog
    sjmp  begin        ; repeat forever...

; ====================================================
;  subroutine DAC - digital-to-analog conversion
;  input    : none
;  output   : uses P5 bits 5.0 to 5.3 to execute a DAC.
;             the DAC sholud be connected to the bits as
;             follows:
;   P5.0 to DAC CS\   (DAC0832 pin 1)
;   P5.1 to DAC WR\   (DAC0832 pins 2 and 18)
;   P5.2 to DAC ILE   (DAC0832 pin 19)
;   P5.3 to DAC XFER\ (DAC0832 pin 17)
;  destroys : P5 but no other register
; ----------------------------------------------------
DAC:
        mov   P5, #0FBh
        mov   P5, #0FCh
        mov   P5, #0FBh
        mov   P5, #0F5h
        mov   P5, #0FBh
        ret

; ====================================================
;
; end of program
