; ----------------------------------------------------
; Digit2.asm      Last Update:10/27/91
;
; Simple Push Button - Display Example
;
; ----------------------------------------------
; system calls              registers used
; ----------------------------------------------
 crlf      equ  0115h  ; a
 display   equ  011bh  ; a
 print     equ  0136h  ; a, dptr
 prthex    equ  013fh  ; a, r2

; ====================================================
;       m a i n    p r o g r a m
; UIOD connections
;
; LOW DIGIT    P4     : output (segment a to P4.0, ...
;                               segment g to P4.6)
; PB0          P5.0   : input
; ----------------------------------------------------

      org   8000h ; run using the monitor G8000 command
      setb  P5.0  ; prepare P5.0 for input
      mov   b, #0 ; current count

      mov   a, b          ; load a with current count
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit
      lcall print         ; send message to host
      db    "current count is ",0
      mov   a, b          ; get current count
      lcall prthex        ; echo count to host
      lcall crlf          ; start a new line

loop:
      jb    P5.0, loop    ; stay here until PB pressed
PBdown:
      jnb   P5.0, PBdown  ; stay here until PB released
      inc   b             ; update count
      anl   b, #0fh       ; modulus 0fh
      mov   a, b          ; put current count in a
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit
      lcall print         ; send message to host
      db    "current count is ",0
      mov   a, b          ; get current count
      lcall prthex        ; echo count to host
      lcall crlf          ; start a new line

      sjmp loop           ; repeat forever...

; ====================================================
; end of program
