; ----------------------------------------------------
; Digit4.asm      Last Update:10/27/91
;
; Simple Push Button - Display Example
;
; ====================================================
;       m a i n    p r o g r a m
; UIOD connections
;
; LOW DIGIT    P4     : output (segment a to P4.0, ...
;                               segment g to P4.6)
; PB0          P5.0   : input
; ----------------------------------------------------

      org   8000h ; run using the monitor G8000 command
      setb  P5.0  ; prepare P5.0 for input
      mov   b, #0 ; current count

      mov   a, b          ; load a with current count
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit
loop:
      jb    P5.0, loop    ; stay here until PB pressed
PBdown:
      jnb   P5.0, PBdown  ; stay here until PB released
      inc   b             ; update count
      anl   b, #0fh       ; modulus 0fh
      mov   a, b          ; put current count in a
      lcall display       ; get display pattern
      mov   P4, a         ; display the digit

      sjmp loop           ; repeat forever...

; ====================================================
;  subroutine display - display string
;  input    : nibble in accumulator
;  output   : 7-segment pattern in accumulator
;             (acc.0 is segment a, acc.6 is segment g)
;  destroys : a
; ----------------------------------------------------
display:
        inc  a
        movc a, @a+pc
        ret
        db  0c0h  ; 0
        db  0f9h  ; 1
        db  0a4h  ; 2
        db  0b0h  ; 3
        db  99h  ; 4
        db  92h  ; 5
        db  82h  ; 6
        db  0f8h  ; 7
        db  80h  ; 8
        db  90h  ; 9
        db  88h  ; a
        db  83h  ; b
        db  0c6h  ; c
        db  0a1h  ; d
        db  86h  ; e
        db  8eh  ; f
; ====================================================
;
; end of program
;
