types	equ	21h
isrom	bit	21h.2
isram	bit	21h.3
issfr	bit	21h.4
isint	bit	21h.5
isbit	bit	21h.6

val	data	40h

editmem:
	anl	types,#83h	; clear memory types
nstyp:	call	ilprt
	db	CR,LF,'Rom rAm Sfr Int Bit : ',0
	call	getchr
	clr	acc.5		; force upper
	cjne	a,#'R',nsrom
	setb	isrom
nsrom:	cjne	a,#'A',nsram
	setb	isram
nsram:	cjne	a,#'S',nssfr
	setb	issfr
nssfr:	cjne	a,#'I',nsint
	setb	isint
nsint:	cjne	a,#'B',nsbit
	setb	isbit
nsbit:	mov	a,types
	anl	a,#7ch		; mask type bits
	jnz	gottyp
	call	ilprt
	db	CR,LF,7,'Invalid memory type.',0
	jmp	nstyp
gottyp:	call	ilprt
	db	cr,lf,'Edit start address  : ',0
	call	getln
	mov	r0,#strval
;================================

	lcall	get_address	; to r2:r3
	jnc	edmem2
	jmp	badadr
edmem2:
	using	0
	mov	ar6,r2
	mov	ar7,r3
;================================
edit_loop:
	call	crlf
	call	shoaddr
	call	getmem		; get current value, bumps mem pointer
	call	binhex		; convert to ascii hex
	jb	isbit,j1n1
	call	sndchr		; show current high nibble
j1n1:	mov	a,b
	call	sndchr		; show current low nibble
	call	prtspc
	call	prtspc
	mov	val,#0		; clear value
	jb	isbit,j1n2

ghn1:	call	getchr
	cjne	a,#cr,gnc3
	jmp	edit_loop
gnc3:	call	sndchr
	cjne	a,#'.',gnc1
	jmp	edit_done
gnc1:	call	aschex
	swap	a
	anl	a,#0f0h
	mov	val,a

j1n2:	call	getchr
	cjne	a,#cr,gnc4
	jmp	edit_loop
gnc4:	call	sndchr
	cjne	a,#'.',gnc2
	jmp	edit_done
gnc2:	call	aschex
	anl	a,#0fh
	orl	a,val
	mov	val,a

	clr	c
	mov	a,r7
	subb	a,#1
	mov	r7,a
	mov	a,r6
	subb	a,#0
	mov	r6,a

	mov	a,r3		; get value
	call	putmem

	jmp	edit_loop
edit_done:
	ret
	
badval:	call	crlf
;badadr:	jmp	badprm
;================================
putmem:	mov	dph,r6
	mov	dpl,r7
	mov	r1,dpl		; low byte address to r1
	mov	a,val
	jnb	isrom,noprom
	movx	@dptr,a
noprom:	jnb	isram,nopram
	movx	@dptr,a
;
nopram:	jnb	issfr,nopsfr
	mov	b,r1		; address to B
	mov	r2,val
	call	putint
	mov	dph,r6
	mov	dpl,r7
;
nopsfr:	jnb	isint,nopint
	mov	b,r1
	mov	r2,val
	call	putint
	mov	dph,r6
	mov	dpl,r7
;
nopint:	jnb	isbit,nopbit
	rrc	a		; bit value to carry
	mov	a,r1		; bit address to ACC
	call	putbit
	mov	dph,r6
	mov	dpl,r7
nopbit:	inc	dptr
	mov	r6,dph
	mov	r7,dpl
	ret
;
;================================
getmem:	mov	dph,r6
	mov	dpl,r7
	mov	r1,dpl
	jnb	isrom,nogrom
	clr	a
	movc	a,@a+dptr
nogrom:	jnb	isram,nogram
	movx	a,@dptr
nogram:	jnb	issfr,nogsfr
	mov	a,r1		; address to ACC
	call	readint
	mov	dph,r6
	mov	dpl,r7
nogsfr:	jnb	isint,nogint
	mov	a,@r1
nogint:	jnb	isbit,nogbit
	mov	a,r1
	call	getbit
	clr	a
	rlc	a		; put bit in a
	mov	dph,r6
	mov	dpl,r7
nogbit:	inc	dptr
	mov	r6,dph
	mov	r7,dpl
	ret
;
;================================
; put bit in carry to bit address in ACC
putbit:
	mov	dptr,#writebit+1
	movx	@dptr,a		; write bit address
	inc	dptr
	inc	dptr
	movx	@dptr,a		; read bit address
	jmp	writebit
;
; get bit from bit address in ACC to carry
getbit:
	mov	dptr,#readbit+1
	movx	@dptr,a
	jmp	readbit

writebit:	mov	20h.0,c
readbit:	mov	c,20h.0
	ret

;================================
prtspc:	mov	a,#' '
	jmp	sndchr
;================================
shoaddr:
	call	prtspc
	mov	a,types
	anl	a,#70h
	jz	print_addr
	call	prtspc
	call	prtspc
	ajmp	shobyte
print_addr:
	mov	a,r6		; high byte of address
	call	prtrad
shobyte:
	mov	a,r7		; low byte of address
	call	prtrad
	mov	a,#':'
	call	sndchr
	call	prtspc
	call	prtspc
	ret
;================================
; get address to R2:R3
get_address:
	pushreg	r6
	pushreg	r7
	mov	r1,#src
	call	getaddr
	mov	r3,src
	mov	r2,src+1
	popreg	r7
	popreg	r6
	ret
;================================
; read internal memory pointed by ACC to ACC
readint:

	mov	dptr,#rdinst+1
	movx	@dptr,a
	sjmp	rdinst
;================================
; write internal memory pointed by B with r2
putint:
	mov	dptr,#wrinst+1	
	mov	a,b
	movx	@dptr,a		; store write address
	inc	dptr
	inc	dptr
	movx	@dptr,a		; store read address
wrinst:	mov	0,r2		; modified 
rdinst:	mov	a,0		; modified
	ret

$include(binhex.asm)


