; ----------------------------------------------------
; EXP-TON1.ASM          Last Update:10/27/91
;
;  Simple Tone Generator 1
;
; ====================================================
; UIOD connections
;
;  Connect P4.0 to the speaker.  The speaker must be
;    connected between P4.0 and Vcc (5 volts) via a
;    10uF to 100uF capacitor.
;  Connect P1.0 to Push Button 0.
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; --- port definitions -------------------------------
; input ports
  Button    equ  90h   ; port bit P1.0
; output ports
  Speaker   equ 0E8h   ; port bit P4.0
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 crlf      equ  0115h  ; a
 inkey     equ  012ah  ; a
 os_return equ  0130h
 print     equ  0136h  ; a, dptr
 prthex    equ  013fh  ; a, r2
; ----------------------------------------------------
; --- origin at the beginning of RAM -----------------
   org   8000h
; --- program starts here ----------------------------
    lcall print
    db "program begins...", 10,13,0
    setb  Button         ; prepare Push Button for input

loop:
    lcall inkey
    cjne  a, #3, continue
    lcall print          ; print message
    db    10,13, "CTL-C received - program terminates", 10,13,0
    ljmp  os_return      ; return to OS

continue:
    jb    Button, loop   ; loop while Button not pressed

    mov   a, #40h        ; try different values
    lcall Tone           ; generate sound
    sjmp  loop           ; repeat

; ::::::::::::::::::::::::::::::::::::::::::::::::::::
; --- subroutines ------------------------------------
; ====================================================
;  subroutine Tone
;   drives the speaker while Button is pressed
;  input    : tone period in accumulator
;             this is not the true period! - just a
;             count value
;  output   : speaker connected to P1.0
;  destroys : a, r0
; ----------------------------------------------------
Tone:
        mov   r0, a      ; save period in r0
        setb  Speaker    ; speaker voltage high
S_on:   djnz  r0, S_on   ; wait a little

        mov   r0, a      ; refresh period
        clr   Speaker    ; speaker voltage low
S_off:  djnz  r0, S_off  ; wait a little

       jnb Button, Tone  ; repeat while Button pressed
       ret               ; return when Button released

; ====================================================
; end of program
