; Convert a value in current radix to binary word
; input:
; r0 has addr of buffer
; r1 has addr of result
getrad:	mov	@r1,#0		; clear lo
	inc	r1
	mov	@r1,#0		; clear hi
	dec	r1
gr1:	mov	dptr,#radlst
	mov	a,@r0		; get char from buffer
	cjne	a,#'a',gr1a	; is it lowercase ?
gr1a:	jc	gr1b
	clr	acc.5		; force uppercase
gr1b:	mov	temp,a
	mov	r3,radix	; # of possible chars to scan
gr2:	movx	a,@dptr	
	cjne	a,temp,nilrad	; in list ?
	call	radbin		; yes
	inc	r0
	jmp	gr1		; continue reading buffer
nilrad:	inc	dptr
	djnz	r3,gr2
	ret			; not in radix list

; r1 has addr of result
radbin:	push	b
	mov	b,a		; get char
	pushreg	r0
	push	b		; save char
	mov	a,@r1
	mov	r6,a
	inc	r1
	mov	a,@r1
	mov	r7,a		; multiplicand
	dec	r1
	mov	r4,radix	; shift by current radix
	mov	r5,#0		; multiplier
	pushreg	r1
	lcall	mul16		; val = val * radix
	popreg	r1
	pop	acc		; restore char
	clr	c
	call	nib		; make 0-f
	add	a,r6
	mov	@r1,a
	inc	r1
	mov	a,r7
	addc	a,#0
	mov	@r1,a
	dec	r1
	popreg	r0
	pop	b
	ret
;
;list of valid characters for any radix
; 0 - 1 for binary	2
; 0 - 7 for octal	8
; 0 - 9 for decimal	10
; 0 - f for hexadecimal	16
radlst:	db	'0123456789ABCDEF',0

