; ADDQUE
; on stack:
; call to here
; Word Addr of process pushed hi then lo 
; byte desired register bank
; Word tick count pushed hi then lo
;
; Data is stored low then high which makes it 
; easier to decrement word tick.
; QUEUE.INC has MRKT macro to insert a job.
; things to do:
; 1) get job #, exit if none available
; 2) push post-process routine at bottom of stack
; 3) push completion routine next
; 4) push sfr's on stack with ipl_synch
; 5) push registers on stack
; 6) push kernal exit routine
; 7) save process context on process header for job #
; 8) get a free node
; 9) put sp,job#,reg bank,tick count in node
;10) insert node on wait list
; to make code easier to read:

insrtq:	clr	ea		; disable interrupts
	pop	acc		; high ret from call to here
	mov	r0,a
	pop	acc		; low ret

	mov	dptr,#retadr
	movx	@dptr,a		; store low ret addr
	inc	dptr
	mov	a,r0
	movx	@dptr,a		; store hi ret addr
	
	clr	qerr.no_job
	mov	dptr,#ajobn	; available job number bit list
	movx	a,@dptr
	jnz	iq1
	setb	qerr.no_job
	call	querr
	db	7,'No job #',cr,lf,0
	jmp	iqxit
	
iq1:	mov	r4,#0		; initialize job counter
	mov	r0,a		; save bit list
	mov	r1,#1		; bit mask
iq2:	rrc	a		; first bit is monitor which is clear
	jc	iq3		; we have a job number
	xch	a,r1
	rl	a		; next bit mask
	xch	a,r1
	inc	r4		; increment job counter
	sjmp	iq2
iq3:	mov	a,r1
	cpl	a		; not bit mask
	mov	r1,a
	mov	a,r0		; get bit list
	anl	a,r1		; mask out job
	movx	@dptr,a		; save bit list
; job # is in R4
	pop	acc
	mov	r6,a		; comp low
	pop	acc
	mov	r7,a		; comp high
	
	pop	acc		; desired reg bank 0,1,2,3
	rl	a
	rl	a
	rl	a		; reg bank 0,8,16,24
	mov	r5,a		; save reg bank value

	popreg	Rticl
	popreg	Rtich		; get ticks to R3:R1
; init stack area
	mov	a,r4		; get job #
	call	getphd		; dptr has address of process header
	mov	r2,dpl		; save base
;
; clear process header
	mov	r0,#phdsiz-1
	clr	a
clrphd:	movx	@dptr,a
	inc	dpl		; no need to change dph
	djnz	r0,clrphd
	mov	a,#0e5h
	movx	@dptr,a
	
	mov	a,r2
	push	acc		; save phd base
	push	dph
	call	ilprt
	db	'Inserting job ',0
	mov	a,r4
	call	prtrad
	call	ilprt
	db	' @ ',0
	pop	dph
	mov	dpl,r2
	call	prtaddr
	call	crlf
	pop	acc
	mov	r2,a		; get phd base
	
;init registers
	mov	a,r2		; phd base
	add	a,r5		; reg bank address
	mov	dpl,a
	store	#000h
	store	#011h
	store	#022h
	store	#033h
	store	#044h
	store	#055h
	store	#066h
	store	#077h
;
	mov	a,r2		; phd base
	add	a,#stack_start
	mov	dpl,a
	mov	r0,#low rundown
	store	r0		; (0)
	mov	r0,#high rundown
	store	r0		; (1)
	store	r6		; (2) low comp
	store	r7		; (3) high comp
	store	r5		; (4) psw set to desired reg bank
	store	#0aah		; (5) acc
	store	#0bbh		; (6) b
	store	#0ddh		; (7) dpl
	store	#0ddh		; (8) dph
	mov	r0,#low krnlxit
	store	r0		; (9)
	mov	r0,#high krnlxit
	store	r0		; (10)
;
; add node to the WAIT list.
; Initialize job information

	clr	qerr.nnodins
	mov	dptr,#FREE	; point to free list
	acall	remque		; get a node from the FREE list
	jnz	adq2
	setb	qerr.nnodins
	call	querr
	db	7,'No node',cr,lf,0
	jmp	iqxit
adq2:
; A = node, r4 = job #,  r3:r1 = ticks
	mov	b,a		; B = node
	mov	r2,#stack_start + 10
	call	initialize_node	; returns node in A
	mov	a,b
	mov	dptr,#WAIT	; put node on wait list
	acall	insque		; insert at tail of wait queue

iqxit:	mov	dptr,#retadr
	movx	a,@dptr
	push	acc		; low ret
	inc	dptr
	movx	a,@dptr
	push	acc		; high ret
	setb	ea
	ret	
$eject

