checksum	data	42
load:	call	getchr			; get a byte
	cjne	A,#':',load		; wait for a colon
	mov	checksum,#0		; zero checksum
	acall	bhex			; get # of bytes to load
	jz	endfl			; none to load
	mov	R2,A			; save byte count
	acall	tapehl			; get load address
; A has command byte
rloop:	acall	bhex			; get a byte of data
	movx	@dptr,A			; store data
	mov	00h,A			; save data
	movx	A,@DPTR			; get data just placed
	cjne	A,00h,memerr		; error if not equal
	inc	DPTR			; next memory location
	djnz	R2,rloop		; do byte count
	acall	check			; check
	mov	a,#'.'			; show human
	call	outt
	sjmp	load			; next line of data
;
tapehl:	acall	bhex
	mov	DPH,A			; hi byte load address
	acall	bhex			
	mov	DPL,A			; lo byte load address
;
bhex:	acall	hex			; get high nibble
	swap	A
	mov	R3,A			; save
	acall	hex			; get low nibble
	add	A,R3			; combine
	mov	R3,A			; save
	add	A,checksum		; add to checksum
	mov	checksum,A		; save checksum
	mov	A,R3			; restore byte
	ret
; get a hex value to A	
hex:	call	getchr

; since the data is always valid, no error checking done
; if there was , what can we do about it, this is a boot loader
nib:	clr	c			; clear carry
	subb	A,#'0'			; subtract bias
	jnb	ACC.4,nib3		; if < 10
	subb	A,#7			; make A-F
nib3:	ret
;
check:	acall	bhex			; get last byte which is checksum
	mov	a,checksum
	jz	ckok
	mov	a,#'E'
	call	outt
	sjmp	error			; oops
ckok:	ret				; ok
;	
endfl:	acall	tapehl			; get start address
	mov 	R0,A			; save command
	acall	bhex			; get last checksum byte
	mov	A,R0
	cjne	A,#1,error
	jmp	jpchl

memerr:	mov	a,#'M'
	call	outt
	call	prtaddr
	sjmp	oops
	
error:	mov	a,#'E'
	call	outt
oops:	pop	acc
	pop	acc
	jmp	lxit	
;
jpchl:	call	crlf
	mov	a,#'G'
	call	outt
	call	prtaddr
lxit:	ret

