
; all macros arguments are destination,source with high byte first

isgt	equ	1
islt	equ	2
isge	equ	3
isle	equ	4
iseq	equ	5

lc1	set	100
lc2	set	200
lc3	set	300

dsc_byte	equ	1
dsc_word	equ	2
dsc_long	equ	4
dsc_quad	equ	8
dsc_string	equ	16
dsc_warray	equ	32
dsc_larray	equ	64
; words are low longs so they line up for math with longs

long1	data	24h
long2	data	28h
long3	data	2ch

word1	data	26h
word2	data	2Ah
word3	data	2Eh

word4	data	24h
word5	data	28h
word6	data	2ch

l1h	equ	long1
l1l	equ	long1+2
l2h	equ	long2
l2l	equ	long2+2
l3h	equ	long3
l3l	equ	long3+2

w1h	equ	word1
w1l	equ	word1+1
w2h	equ	word2
w2l	equ	word2+1
w3h	equ	word3
w3l	equ	word3+1
w4h	equ	word4
w4l	equ	word4+1
w5h	equ	word5
w5l	equ	word5+1
w6h	equ	word6
w6l	equ	word6+1

preamble	equ	4

word	macro	arg
oadr	set $
	db	dsc_word	;; type
	db	0		;; class
	dw	2		;; size
arg:
	cseg at (oadr + preamble + dsc_word)
	endm

long	macro	arg
oadr	set $
	db	dsc_long	;; type
	db			;; class
	dw	4		;; size
arg:
	cseg at (oadr + preamble + dsc_long)
	endm

string	macro	arg,text
oadr	set $
	db	dsc_string	;; type
	db	0		;; class
	dw	slen		;; size
arg:
	db	text
	db	0
slen	set	$ - arg
	cseg at (oadr + preamble + slen)
	endm

; word array
warray	macro	arg,size
oadr	set $
alen	set size * dsc_word
	db	dsc_warray	;; type
	db	dsc_word	;; class = cell size
	dw	alen		;; size
arg:
	cseg at	(oadr + preamble + alen)
	endm

; long array
larray	macro	arg,size
oadr	set $
alen	set size * dsc_long
	db	dsc_larray	;; type
	db	dsc_long	;; class = cell size
	dw	alen		;; size
arg:
	cseg at	(oadr + preamble + alen)
	endm
;================================================================	
; add internal immediate
; increment internal word with constant
adi	macro	idst,constant
	mov	dptr,#constant
	mov	r0,#idst
	call	rtadi
	endm
;
; push array data to data stack 
argstk	macro	abas,aidx
; word
	lda	long1,abas,aidx		;; returns b with byte count
	pushw	word5			;; word5 is hi long1
	mov	a,#4
	cjne	a,b,argsk2
	pushw	word1			;; word1 is low long1
argsk2:
	endm
; arithmetic shift left external word
aslx	macro	arg1
	ldx	word1,arg1
	jmp	rtasl
	endm
;
; arithmetic shift right external word
asrx	macro	arg1
	ldx	word1,arg1
	jmp	rtasr
	endm

;
; add external immediate
; increment/decrement external value with constant
axi	macro	xdst,constant
	ldx	word1,xdst
	ldi	word2,constant
	mov	dptr,#xdst-preamble
	call	rtaxi
	lxd	xdst,word2
	endm
;
; branch equal
beq	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jnb	Z,$+6		;; not equal
	ljmp	addr
	endm
;
; branch greater or equal
bge	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jc	$+8		;; is less
	jb	Nflag,$+6		;; is negative
	ljmp	addr
	endm
;
; branch greater	
bgt	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jb	Z,$+9		;; is equal
	jb	Nflag,$+6		;; is negative
	ljmp	addr
	endm
;
; branch less than or equal	
ble	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jb	Z,$+5		;; is equal
	jnc	$+5		;; is greater
	ljmp	addr
	endm
;
; branch less than
blt	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jb	Z,$+8		;; is equal
	jnc	$+5		;; is greater
	ljmp	addr
	endm
;
; branch not equal
bne	macro	arg1,arg2,addr
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	jb	Z,$+6		;; is equal
	ljmp	addr
	endm
;
; compare external arg1 to external arg2
cmp	macro	arg1,arg2
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtcmp
	endm
;
fixmpy	macro	arg1,aptr,aidx
	lda	word3,aptr,aidx	;; multiplicand
	ldx	word1,arg1	;; multiplier
	call	fix_mpy		;; word1 = fix_mpy(vr,fr[j])
	endm
;
for	macro	var1,argu,var2,con1
	sysfor	var1,argu,var2,con1, %lc1, %lc2
	endm
;
; integer addition						*
iadd	macro	arg1,arg2
	ldx	word1,arg1
	ldx	word2,arg2
	call	rtadd
	endm
;
iand	macro	arg1,arg2
	ldx	word1,arg2
	ldx	word2,arg1
	call	rtand
	endm
;
; integer division						*
idiv	macro	arg1,arg2
	mov	r0,#word2	;; dividend_hi
	mov	r2,#2
	call	mbclr
	ldx	word3,arg1	;; dividend_lo
	ldx	word1,arg2	;; divisor
	call	rtdiv
	endm
;
; integer multiplication					*
imul	macro	arg1,arg2
	ldx	word3,arg1	;; multiplicand
	ldx	word1,arg2	;; multiplier
	call	rtmul
	endm
;
; integer subtraction
isub	macro	arg1,arg2
	ldx	word1,arg2
	ldx	word2,arg1
	call	rtsub
	endm
;
; shift arg1 left arg2 times
; return word1 with result
isvl	macro	arg1,arg2
	isvl1	arg1,arg2,%lc3
	endm
		
isvl1	macro	arg1,arg2,lin3
	ldx	word1,arg2		; get shift count
	mov	b,w1l
	ldx	word1,arg1
l&lin3:	clr	c
	mov	r0,#word1
	mov	r2,#2
	call	mbsvl
	djnz	b,l&lin3
lc3 set lc3 + 1
	endm
;
; shift arg1 right arg2 times
; return word1 with result
isvr	macro	arg1,arg2
	isvr1	arg1,arg2,%lc3
	endm
	
isvr1	macro
	ldx	word1,arg2
	mov	b,w1l
	ldx	word1,arg1
l&lin3:	clr	c
	mov	r0,#word1
	mov	r2,#2
	call	mbsvr
	djnz	b,l&lin3
lc3 set lc3 + 1
	endm
;
			
; load array immediate
; load array ANAME with CONSTANT
lai	macro	aname,aindex,constant
	ldi	word3,constant
	ldx	word2,aindex
	mov	dptr,#aname-preamble
	call	indexer			;; dptr has addr of indexed array
	mov	r0,#word3
	call	rtlxd2
	endm
;
; load array data
; load array ANAME with internal ARG1
; indexer returns B with byte count
lad	macro	aname,aindex,arg1
	pushw	word2
	ldx	word2,aindex
	mov	dptr,#aname-preamble
	call	indexer			;; dptr has addr of indexed array
	popw	word2
	mov	r0,#arg1
	mov	r2,b
	call	rtlxd2
	endm
;
; load data array
; load internal ARG1 from array ANAME
; indexer returns B with byte count, 
; and dptr with indexed array address
; uses word2 so it's saved if not destination
lda	macro	arg1,aname,aindex
	if(arg1<>word2)
	  if(arg1<>long2)
	    pushl	long2
	  endif
	endif
	ldx	word2,aindex
	mov	dptr,#aname-preamble
	call	indexer
	mov	r0,#arg1
	mov	r2,b
	call	rtldx2
	if(arg1<>word2)
	  if(arg1<>long2)
	    popl	long2
	  endif
	endif
	endm
;
; load data data
; duplicate the contents of internal long src1 to internal long dst1
lddl	macro	dst1,src1
	mov	r0,#src1
	mov	r1,#dst1
	mov	r2,#4
	call	rtldd
	endm
;
; duplicate the contents of internal word src1 to internal word dst1
lddw	macro	dst1,src1
	mov	r0,#src1
	mov	r1,#dst1
	mov	r2,#2
	call	rtldd
	endm


;
; load data immediate
; load internal word with constant
ldi	macro	adst,constant
	mov	r0,#adst
	mov	dptr,#constant
	call	rtldi
	endm
;
; load data external
; move the contents of external ASRC to internal ADST
ldx	macro	adst,asrc
	mov	dptr,#asrc-preamble
	mov	r0,#adst
	call	rtldx
	endm
;
; long to word
; 1 long to 2 words high and low
ltw	macro	w1,w2,larg
	pushl	larg
	popw	w2
	popw	w1
	endm
;
; load external data
; move the contents of internal arg2 to external arg1		*
lxd	MACRO	ARG1,ARG2
	mov	r0,#arg2
	mov	dptr,#arg1-preamble
	call	rtlxd
	endm
;
; load external immediate
; load external word with constant				*	
lxi	macro	arg1,constant
	ldi	word1,constant		;; load constant into internal
	lxd	arg1,word1		;; load external with internal
	endm
;
; duplicate external value
lxx	macro	dst1,src1
	ldx	word2,src1
	lxd	dst1,word2
	endm
;
; negate word referenced by r0
negw	macro	arg
	mov	r0,#arg
	mov	r2,#2
	call	mbneg	
	endm
;
; next token at bottom of for loop
next	macro
	call	donext
	endm
; 	
popb	macro	arg
	mov	r0,#arg
	mov	r2,#1
	call	rtpop
	endm
;
popw	macro	arg
	mov	r0,#arg
	mov	r2,#2
	call	rtpop
	endm
;
popl	macro	arg
	mov	r0,#arg
	mov	r2,#4
	call	rtpop
	endm
;
pushb	macro	arg
	mov	r0,#arg
	mov	r2,#1
	call	rtpush
	endm
;
pushw	macro	arg
	mov	r0,#arg
	mov	r2,#2
	call	rtpush
	endm
;
pushl	macro	arg
	mov	r0,#arg
	mov	r2,#4
	call	rtpush
	endm
;
; subtract internal immediate
; decrement internal word with constant
sdi	macro	idst,constant
	mov	dptr,#constant
	mov	r0,#idst
	call	rtsdi
	endm
;
; shift internal long right
slr	macro	warg
	mov	r0,#warg
	mov	r2,#4
	clr	c
	call	mbsvr		; right shift = divide by 2
	endm
;
sqr	macro	larg,warg1
	if(warg1=word1)
	  lddw	word2,warg1	;; multiplicand = multiplier
warg2 set word2
warg3 set word3
	endif
	if(warg1=word2)
	  lddw	word1,warg1	;; multiplicand = multiplier
warg2 set word1
warg3 set word3
	endif
	if(warg1=word3)
	  lddw	word2,warg1	;; multiplicand = multiplier
warg2 set word2
warg3 set word1
	endif
	mov	multiplier,#warg1
	mov	multiplicand,#warg2
	mov	product_lo,#warg3
	mov	r2,#2
	call	mbmul
	wtl	larg,warg1,warg3	;; convert to long
	endm
;
; shift value left b times
svl	macro	arg
	ldx	word2,arg
	call	rtsvl
	endm
;
; shift value right b times
svr	macro	arg
	ldx	word2,arg
	call	rtsvr
	endm
;
;
; shift internal word right
swr	macro	warg
	mov	r0,#warg
	mov	r2,#2
	clr	c
	call	mbsvr		; right shift = divide by 2
	endm
;
sysfor	macro	var1,argu,var2,con1,lin1,lin2
	jmp	l&lin2
;; This is where 'next' comes to. No need to worry about
;; who comes first in nested for loops. The inner most
;; loop is first on stack. A lifo you might say. The 'next'
;; routine saves the address of where to go if condition fails.
l&lin1:
	iadd	var1,con1		;; bump step counter
	lxd	var1,word2

	if(argu=1)			;; greater than
	bgt	var1,var2,l&lin2
	endif
	if(argu=2)			;; less than
	blt	var1,var2,l&lin2
	endif
	if(argu=3)			;; greater than or equal
	bge	var1,var2,l&lin2
	endif
	if(argu=4)			;; less than or equal
	ble	var1,var2,l&lin2
	endif
;; We're here because the condition failed. The 'next'
;; macro called the 'next' function which places a return
;; address of where we need to go.
	ldx	word2,retadr		;; get address after 'next' call
	push	w2l
	push	w2h
	ret				;; for done, continue
;; We come here in the beginning and for each iteration
;; of the 'for' loop. We place a return address for the 'next'
;; function.
l&lin2:
	mov	a,#low l&lin1	;; setup to return back here
	push	acc
	mov	a,#high l&lin1
	push	acc
;; internal counters for labels. The whole idea is not to have
;; to know where to go on in the 'for' loop.
lc1 set lc1 + 1
lc2 set lc2 + 1
	endm
;
; word to long
; 2 words high and low to 1 long
wtl	macro	larg,w1,w2
	pushw	w2
	pushw	w1
	popl	larg
	endm
;

