; ----------------------------------------------------
; Math-8.asm      Last Update:10/24/92
;
; Math routines Example
;
; ====================================================
; UIOD connections
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; internal memory use

  X0   equ   70h
  X1   equ   71h
  X2   equ   72h
  X3   equ   73h

  Y0   equ   74h
  Y1   equ   75h
  Y2   equ   76h
  Y3   equ   77h

  Z0   equ   78h
  Z1   equ   79h
  Z2   equ   7ah
  Z3   equ   7bh
  Z4   equ   6dh
  Z5   equ   6eh
  ZEXP equ   6fh

  PR0  equ   7Ch
  PR1  equ   7Dh
  PR2  equ   7Eh
  PR3  equ   7Fh

  X    equ     X0
  XA   equ     X0
  XL   equ     X0
  XAL  equ     X0
  XT   equ     X0
  XTL  equ     X0
  XH   equ     X1
  XAH  equ     X1
  XTH  equ     X1

  Y    equ     Y0
  YA   equ     Y0
  YL   equ     Y0
  YAL  equ     Y0
  YT   equ     Y0
  YTL  equ     Y0
  YH   equ     Y1
  YAH  equ     Y1
  YTH  equ     Y1

  Z    equ     Z0
  ZA   equ     Z0
  ZL   equ     Z0
  ZAL  equ     Z0
  ZT   equ     Z0
  ZTL  equ     Z0
  ZAR  equ     Z0
  ZH   equ     Z1
  ZAH  equ     Z1
  ZTH  equ     Z1
  ZAQ  equ     Z1



; bits
  XS   equ     10h     ; X sign bit
  YS   equ     11h     ; Y sign bit
  ZS   equ     12h     ; Z sign bit

  XOV  equ     13h
  ZOV  equ     14h
  ZADJ equ     15h
  ZEXP
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 ascbin    equ  0100h  ; a, r2, error flag
 autoexec  equ  0103h
 beep      equ  0106h  ;  none
 binasc    equ  0109h  ; a
 break     equ  010ch  ; a, (reads accumulator)
 chkbrk    equ  010fh  ; a, (reads serial port)
 cret      equ  0112h  ; a
 crlf      equ  0115h  ; a
 delay     equ  0118h  ; a
 display   equ  011bh  ; a
 getbyt    equ  011eh  ; a, b
 getchr    equ  0121h  ; a
 getchrx   equ  0124h  ; a
 init      equ  0127h
 inkey     equ  012ah  ; a
 mdelay    equ  012dh  ; a
 os_return equ  0130h
 percent   equ  0133h  ; a
 print     equ  0136h  ; a, dptr
 prsphx    equ  0139h  ; a, r2
 prtstr    equ  013ch  ; a
 prthex    equ  013fh  ; a, r2
 sdelay    equ  0142h  ; a
 setintvec equ  0145h  ; a, dptr
 sndchr    equ  0148h  ; a
; ----------------------------------------------------

      org 8000h

; #### TC2AV_SB8 #####################################

      lcall print
      db    0ah, 0dh, "TC2AV_SB8 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input a number (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XT, a
      lcall print
      db    0ah, 0dh, "X Two's Complement : ", 0
      mov   a, XT
      lcall prthex

      lcall TC2AV_SB8


      lcall print
      db    0ah, 0dh, "X Absolute Value : ", 0
      mov   a, XA
      lcall prthex

      lcall crlf
      jb    XS, main1
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main1:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return


; #### AV_SB2TC8 #####################################

      org   8200h

      lcall print
      db    0ah, 0dh, "AV_SB2TC8 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input a number (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XA, a
      lcall print
      db    0ah, 0dh, "X Absolute Value: ", 0
      mov   a, XA
      lcall prthex

      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main2
      setb  XS

main2:
      lcall AV_SB2TC8

      jnb   XOV, main3
      lcall print
      db    0ah, 0dh, "Number is out of range (not in -80h...7Fh)", 0
      ljmp  os_return

main3:
      lcall print
      db    0ah, 0dh, "X Two's complement: ", 0
      mov   a, XT
      lcall prthex

      lcall crlf
      jb    XS, main4
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main4:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return

; #### TC2AV_SB16 #####################################
      org   8400h

      lcall print
      db    0ah, 0dh, "TC2AV_SB16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input the high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XTH, a
      lcall print
      db    0ah, 0dh, "input the low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XTL, a

      lcall print
      db    0ah, 0dh, "X Two's Complement: ", 0
      mov   a, XTH
      lcall prthex
      mov   a, XTL
      lcall prthex

      lcall TC2AV_SB16


      lcall print
      db    0ah, 0dh, "X Absolute Value: ", 0
      mov   a, XAH
      lcall prthex
      mov   a, XAL
      lcall prthex

      lcall crlf
      jb    XS, main5
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main5:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return


; #### AV_SB2TC16 #####################################

      org   8600h

      lcall print
      db    0ah, 0dh, "AV_SB2TC16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input the high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XAH, a
      lcall print
      db    0ah, 0dh, "input the low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XAL, a

      lcall print
      db    0ah, 0dh, "X Absolute Value : ", 0
      mov   a, XAH
      lcall prthex
      mov   a, XAL
      lcall prthex

      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main6
      setb  XS

main6:
      lcall AV_SB2TC16

      jnb   XOV, main7
      lcall print
      db    0ah, 0dh, "Number is out of range (not in -8000h...7FFFh)", 0
      ljmp  os_return

main7:
      lcall print
      db    0ah, 0dh, "X Two's Complemt: ", 0
      mov   a, XTH
      lcall prthex
      mov   a, XTL
      lcall prthex

      lcall crlf
      jb    XS, main8
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main8:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return

; #### SMUL8 #####################################

      org   8800h

      lcall print
      db    0ah, 0dh, "SMUL8 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input magnitude of X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XA, a
      lcall prthex
      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main9
      setb  XS

main9:
      lcall print
      db    0ah, 0dh, "input magnitude of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   YA, a
      lcall prthex
      clr   YS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main10
      setb  YS

main10:

      lcall SMUL8

      lcall print
      db    0ah, 0dh, "X*Y (magnitude): ", 0
      mov   a, ZAH
      lcall prthex
      mov   a, ZAL
      lcall prthex

      lcall crlf
      jb    ZS, main11
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main11:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return


; #### SDIV8 #####################################

      org   8a00h

      lcall print
      db    0ah, 0dh, "SDIV8 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input magnitude of X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XA, a
      lcall prthex
      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main12
      setb  XS

main12:
      lcall print
      db    0ah, 0dh, "input magnitude of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   YA, a
      lcall prthex
      clr   YS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main13
      setb  YS

main13:

      lcall SDIV8

      jnb   ZOV, main14
      lcall print
      db    0ah, 0dh, "Error: division by zero", 0
      ljmp  os_return

main14:
      lcall print
      db    0ah, 0dh, "X/Y (magnitude of quotient): ", 0
      mov   a, ZAQ
      lcall prthex

      lcall print
      db    0ah, 0dh, "X/Y (magnitude of remainder): ", 0
      mov   a, ZAR
      lcall prthex

      lcall crlf
      jb    ZS, main15
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main15:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return



; #### ADD16 #####################################

      org   8c00h

      lcall print
      db    0ah, 0dh, "ADD16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall ADD16

      jnb   ZOV, main16
      lcall print
      db    0ah, 0dh, "X+Y is out of range (greater than FFFFh)", 0
      ljmp  os_return

main16:
      lcall print
      db    0ah, 0dh, "Z=X+Y: ", 0
      mov   a, ZH
      lcall prthex
      mov   a, ZL
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### SUB16 #####################################

      org   8e00h

      lcall print
      db    0ah, 0dh, "SUB16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall SUB16

      jnb   ZOV, main17
      lcall print
      db    0ah, 0dh, "X-Y is out of range (X<Y)", 0
      ljmp  os_return

main17:
      lcall print
      db    0ah, 0dh, "Z=X-Y: ", 0
      mov   a, ZH
      lcall prthex
      mov   a, ZL
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### SUB32 #####################################

      org   9000h

      lcall print
      db    0ah, 0dh, "SUB32 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X3 - X highest byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X3, a
      lcall print
      db    0ah, 0dh, "input X2 ", 0ah, 0dh, 0
      lcall getbyt
      mov   X2, a
      lcall print
      db    0ah, 0dh, "input X1 ", 0ah, 0dh, 0
      lcall getbyt
      mov   X1, a
      lcall print
      db    0ah, 0dh, "input X0 - X lowest byte", 0ah, 0dh, 0
      lcall getbyt
      mov   X0, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, X3
      lcall prthex
      mov   a, X2
      lcall prthex
      mov   a, X1
      lcall prthex
      mov   a, X0
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y3 - Y highest byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   Y3, a
      lcall print
      db    0ah, 0dh, "input Y2 ", 0ah, 0dh, 0
      lcall getbyt
      mov   Y2, a
      lcall print
      db    0ah, 0dh, "input Y1 ", 0ah, 0dh, 0
      lcall getbyt
      mov   Y1, a
      lcall print
      db    0ah, 0dh, "input Y0 - lowest byte", 0ah, 0dh, 0
      lcall getbyt
      mov   Y0, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, Y3
      lcall prthex
      mov   a, Y2
      lcall prthex
      mov   a, Y1
      lcall prthex
      mov   a, Y0
      lcall prthex

      lcall SUB32

      jnb   ZOV, main18
      lcall print
      db    0ah, 0dh, "X-Y is out of range (X<Y)", 0
      ljmp  os_return

main18:
      lcall print
      db    0ah, 0dh, "Z=X-Y: ", 0
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      ljmp  os_return


; #### BMW #####################################

      org   9200h

      lcall print
      db    0ah, 0dh, "BMW test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input byte X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, X
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall BMW

      lcall print
      db    0ah, 0dh, "Z=X*Y: ", 0
      mov   a, Z2
      lcall prthex
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      ljmp  os_return


; #### MUL16 #####################################

      org   9400h

      lcall print
      db    0ah, 0dh, "MUL16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall MUL16

      lcall print
      db    0ah, 0dh, "Z=X*Y: ", 0
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### DIV16 #####################################

      org   9600h

      lcall print
      db    0ah, 0dh, "DIV16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall DIV16
      jnb   ZOV, main19
      lcall print
      db    0ah, 0dh, "Error: division by zero", 0
      ljmp  os_return
main19:
      lcall print
      db    0ah, 0dh, "Z=X/Y (quotient): ", 0
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      lcall print
      db    0ah, 0dh, "Z=X/Y (remainder): ", 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### DIV32 #####################################

      org   9800h

      lcall print
      db    0ah, 0dh, "DIV32 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X3: X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X3, a
      lcall print
      db    0ah, 0dh, "input X2", 0ah, 0dh, 0
      lcall getbyt
      mov   X2, a
      lcall print
      db    0ah, 0dh, "input X1", 0ah, 0dh, 0
      lcall getbyt
      mov   X1, a
      lcall print
      db    0ah, 0dh, "input X0", 0ah, 0dh, 0
      lcall getbyt
      mov   X0, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, X3
      lcall prthex
      mov   a, X2
      lcall prthex
      mov   a, X1
      lcall prthex
      mov   a, X0
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   Y1, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   Y0, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, Y1
      lcall prthex
      mov   a, Y0
      lcall prthex

      lcall DIV32

      jnb   ZOV, main20
      lcall print
      db    0ah, 0dh, "Error: division by zero", 0
      ljmp  os_return
main20:
      lcall print
      db    0ah, 0dh, "Z=X/Y (quotient): ", 0
      mov   a, Z5
      lcall prthex
      mov   a, Z4
      lcall prthex
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      lcall print
      db    0ah, 0dh, "Z=X/Y (remainder): ", 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### SADD16 #####################################

      org   9a00h

      lcall print
      db    0ah, 0dh, "SADD16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall SADD16

      jnb   ZOV, main21
      lcall print
      db    0ah, 0dh, "X+Y is out of range", 0
      ljmp  os_return

main21:
      lcall print
      db    0ah, 0dh, "Z=X+Y: ", 0
      mov   a, ZH
      lcall prthex
      mov   a, ZL
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### SSUB16 #####################################

      org   9c00h

      lcall print
      db    0ah, 0dh, "SSUB16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall SSUB16

      jnb   ZOV, main22
      lcall print
      db    0ah, 0dh, "X-Y is out of range", 0
      ljmp  os_return

main22:
      lcall print
      db    0ah, 0dh, "Z=X-Y: ", 0
      mov   a, ZH
      lcall prthex
      mov   a, ZL
      lcall prthex

      lcall crlf
      ljmp  os_return

; #### SMUL16 #####################################

      org   9e00h

      lcall print
      db    0ah, 0dh, "SMUL16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main23
      setb  XS

main23:

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      lcall SMUL16

      lcall print
      db    0ah, 0dh, "Z=X*Y: ", 0
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      jb    ZS, main24
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main24:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return
      ljmp  os_return

; #### SDIV16 #####################################

      org   0a000h

      lcall print
      db    0ah, 0dh, "SDIV16 test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input X high byte (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   XH, a
      lcall print
      db    0ah, 0dh, "input X low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   XL, a

      lcall print
      db    0ah, 0dh, "X : ", 0
      mov   a, XH
      lcall prthex
      mov   a, XL
      lcall prthex

      clr   XS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main25
      setb  XS
main25:

      lcall print
      db    0ah, 0dh, "input Y high byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YH, a
      lcall print
      db    0ah, 0dh, "input Y low byte", 0ah, 0dh, 0
      lcall getbyt
      mov   YL, a

      lcall print
      db    0ah, 0dh, "Y : ", 0
      mov   a, YH
      lcall prthex
      mov   a, YL
      lcall prthex

      clr   YS
      lcall print
      db    0ah, 0dh, "input '-' for negative", 0ah, 0dh, 0
      lcall getchr
      cjne  a, #'-', main26
      setb  YS
main26:
      lcall SDIV16
      jnb   ZOV, main27
      lcall print
      db    0ah, 0dh, "Error: division by zero", 0
      ljmp  os_return
main27:
      lcall print
      db    0ah, 0dh, "Z=X/Y (quotient): ", 0
      mov   a, Z3
      lcall prthex
      mov   a, Z2
      lcall prthex
      lcall print
      db    0ah, 0dh, "Z=X/Y (remainder): ", 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      lcall crlf
      jb    ZS, main28
      lcall print
      db    "result is POSITIVE", 0
      ljmp  os_return
main28:
      lcall print
      db    "result is NEGATIVE", 0
      ljmp  os_return
      ljmp  os_return



      org   0b000h

#include math.inc


; ====================================================
;
; end of program
