; ----------------------------------------------------
; Math-F.asm      Last Update:10/24/92
;
; Math routines Example
;
; ====================================================
; UIOD connections
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; internal memory use

  X0   equ   70h
  X1   equ   71h
  X2   equ   72h
  X3   equ   73h

  Y0   equ   74h
  Y1   equ   75h
  Y2   equ   76h
  Y3   equ   77h

  Z0   equ   78h
  Z1   equ   79h
  Z2   equ   7ah
  Z3   equ   7bh
  Z4   equ   6dh
  Z5   equ   6eh
  ZEXP equ   6fh

  PR0  equ   7Ch
  PR1  equ   7Dh
  PR2  equ   7Eh
  PR3  equ   7Fh

  AUX0 equ   7Ch
  AUX1 equ   7Dh
  AUX2 equ   7Eh
  AUX3 equ   7Fh

  X    equ     X0
  XA   equ     X0
  XL   equ     X0
  XAL  equ     X0
  XT   equ     X0
  XTL  equ     X0
  XH   equ     X1
  XAH  equ     X1
  XTH  equ     X1

  Y    equ     Y0
  YA   equ     Y0
  YL   equ     Y0
  YAL  equ     Y0
  YT   equ     Y0
  YTL  equ     Y0
  YH   equ     Y1
  YAH  equ     Y1
  YTH  equ     Y1

  Z    equ     Z0
  ZA   equ     Z0
  ZL   equ     Z0
  ZAL  equ     Z0
  ZT   equ     Z0
  ZTL  equ     Z0
  ZAR  equ     Z0
  ZH   equ     Z1
  ZAH  equ     Z1
  ZTH  equ     Z1
  ZAQ  equ     Z1



; bits
  XS   equ     10h     ; X sign bit
  YS   equ     11h     ; Y sign bit
  ZS   equ     12h     ; Z sign bit

  XOV  equ     13h
  ZOV  equ     14h
  ZADJ equ     15h
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 ascbin    equ  0100h  ; a, r2, error flag
 autoexec  equ  0103h
 beep      equ  0106h  ;  none
 binasc    equ  0109h  ; a
 break     equ  010ch  ; a, (reads accumulator)
 chkbrk    equ  010fh  ; a, (reads serial port)
 cret      equ  0112h  ; a
 crlf      equ  0115h  ; a
 delay     equ  0118h  ; a
 display   equ  011bh  ; a
 getbyt    equ  011eh  ; a, b
 getchr    equ  0121h  ; a
 getchrx   equ  0124h  ; a
 init      equ  0127h
 inkey     equ  012ah  ; a
 mdelay    equ  012dh  ; a
 os_return equ  0130h
 percent   equ  0133h  ; a
 print     equ  0136h  ; a, dptr
 prsphx    equ  0139h  ; a, r2
 prtstr    equ  013ch  ; a
 prthex    equ  013fh  ; a, r2
 sdelay    equ  0142h  ; a
 setintvec equ  0145h  ; a, dptr
 sndchr    equ  0148h  ; a
; ----------------------------------------------------

      org 8000h

; #### FMUL #####################################

      lcall print
      db    0ah, 0dh, "FMUL test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input the exponent of X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X2, a
      lcall print
      db    0ah, 0dh, "X exponent: ", 0
      mov   a, X2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X0, a
      lcall print
      db    0ah, 0dh, "mantissa of X", 0ah, 0dh, 0
      mov   a, X1
      lcall prthex
      mov   a, X0
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the exponent of Y (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   Y2, a
      lcall print
      db    0ah, 0dh, "Y exponent: ", 0
      mov   a, Y2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y0, a
      lcall print
      db    0ah, 0dh, "mantissa of Y", 0ah, 0dh, 0
      mov   a, Y1
      lcall prthex
      mov   a, Y0
      lcall prthex

      lcall FMUL

      lcall print
      db    0ah, 0dh, "Z=X*Y exponent: ", 0
      mov   a, Z2
      lcall prthex

      lcall print
      db    0ah, 0dh, "mantissa of Z", 0ah, 0dh, 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      ljmp  os_return


; #### FDIV #####################################
      org 9000h

      lcall print
      db    0ah, 0dh, "FDIV test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input the exponent of X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X2, a
      lcall print
      db    0ah, 0dh, "X exponent: ", 0
      mov   a, X2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X0, a
      lcall print
      db    0ah, 0dh, "mantissa of X", 0ah, 0dh, 0
      mov   a, X1
      lcall prthex
      mov   a, X0
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the exponent of Y (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   Y2, a
      lcall print
      db    0ah, 0dh, "Y exponent: ", 0
      mov   a, Y2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y0, a
      lcall print
      db    0ah, 0dh, "mantissa of Y", 0ah, 0dh, 0
      mov   a, Y1
      lcall prthex
      mov   a, Y0
      lcall prthex

      lcall FDIV

      jnb   ZOV, Fdiv_OK
      lcall print
      db    0ah, 0dh, "Division by zero error ", 0ah, 0dh, 0
      ljmp  os_return

Fdiv_OK:
      lcall print
      db    0ah, 0dh, "Z=X/Y exponent: ", 0
      mov   a, Z2
      lcall prthex

      lcall print
      db    0ah, 0dh, "mantissa of Z", 0ah, 0dh, 0, 0, 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      ljmp  os_return

      org   0B000h

#include math.inc


; ====================================================
;
; end of program
