; ----------------------------------------------------
; Math-F.asm      Last Update:10/24/92
;
; Math routines Example
;
; ====================================================
; UIOD connections
;
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; internal memory use

  X0   equ   70h
  X1   equ   71h
  X2   equ   72h
  X3   equ   73h

  Y0   equ   74h
  Y1   equ   75h
  Y2   equ   76h
  Y3   equ   77h

  Z0   equ   78h
  Z1   equ   79h
  Z2   equ   7ah
  Z3   equ   7bh
  Z4   equ   6dh
  Z5   equ   6eh
  ZEXP equ   6fh

  PR0  equ   7Ch
  PR1  equ   7Dh
  PR2  equ   7Eh
  PR3  equ   7Fh

  AUX0 equ   7Ch
  AUX1 equ   7Dh
  AUX2 equ   7Eh
  AUX3 equ   7Fh

  X    equ     X0
  XA   equ     X0
  XL   equ     X0
  XAL  equ     X0
  XT   equ     X0
  XTL  equ     X0
  XH   equ     X1
  XAH  equ     X1
  XTH  equ     X1

  Y    equ     Y0
  YA   equ     Y0
  YL   equ     Y0
  YAL  equ     Y0
  YT   equ     Y0
  YTL  equ     Y0
  YH   equ     Y1
  YAH  equ     Y1
  YTH  equ     Y1

  Z    equ     Z0
  ZA   equ     Z0
  ZL   equ     Z0
  ZAL  equ     Z0
  ZT   equ     Z0
  ZTL  equ     Z0
  ZAR  equ     Z0
  ZH   equ     Z1
  ZAH  equ     Z1
  ZTH  equ     Z1
  ZAQ  equ     Z1



; bits
  XS   equ     10h     ; X sign bit
  YS   equ     11h     ; Y sign bit
  ZS   equ     12h     ; Z sign bit

  XOV  equ     13h
  ZOV  equ     14h
  ZADJ equ     15h
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 ascbin    equ  0100h  ; a, r2, error flag
 autoexec  equ  0103h
 beep      equ  0106h  ;  none
 binasc    equ  0109h  ; a
 break     equ  010ch  ; a, (reads accumulator)
 chkbrk    equ  010fh  ; a, (reads serial port)
 cret      equ  0112h  ; a
 crlf      equ  0115h  ; a
 delay     equ  0118h  ; a
 display   equ  011bh  ; a
 getbyt    equ  011eh  ; a, b
 getchr    equ  0121h  ; a
 getchrx   equ  0124h  ; a
 init      equ  0127h
 inkey     equ  012ah  ; a
 mdelay    equ  012dh  ; a
 os_return equ  0130h
 percent   equ  0133h  ; a
 print     equ  0136h  ; a, dptr
 prsphx    equ  0139h  ; a, r2
 prtstr    equ  013ch  ; a
 prthex    equ  013fh  ; a, r2
 sdelay    equ  0142h  ; a
 setintvec equ  0145h  ; a, dptr
 sndchr    equ  0148h  ; a
; ----------------------------------------------------

      org 8000h

; #### FADD and FSUB  #####################################

      lcall print
      db    0ah, 0dh, "FADD test", 0ah, 0dh, 0
;      db    0ah, 0dh, "FSUB test", 0ah, 0dh, 0
      lcall print
      db    0ah, 0dh, "input the exponent of X (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   X2, a
      lcall print
      db    0ah, 0dh, "X exponent: ", 0
      mov   a, X2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of X", 0ah, 0dh, 0
      lcall getbyt
      mov   X0, a
      lcall print
      db    0ah, 0dh, "mantissa of X", 0ah, 0dh, 0
      mov   a, X1
      lcall prthex
      mov   a, X0
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the exponent of Y (two characters e.g. 0d)", 0ah, 0dh, 0
      lcall getbyt
      mov   Y2, a
      lcall print
      db    0ah, 0dh, "Y exponent: ", 0
      mov   a, Y2
      lcall prthex

      lcall print
      db    0ah, 0dh, "input the high byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y1, a
      lcall print
      db    0ah, 0dh, "input the low byte of mantissa of Y", 0ah, 0dh, 0
      lcall getbyt
      mov   Y0, a
      lcall print
      db    0ah, 0dh, "mantissa of Y", 0ah, 0dh, 0
      mov   a, Y1
      lcall prthex
      mov   a, Y0
      lcall prthex

      lcall FADD
;      lcall FSUB

      lcall print
      db    0ah, 0dh, "Z=X+Y exponent: ", 0
      mov   a, Z2
      lcall prthex

      lcall print
      db    0ah, 0dh, "mantissa of Z", 0ah, 0dh, 0
      mov   a, Z1
      lcall prthex
      mov   a, Z0
      lcall prthex

      ljmp  os_return






;====================================================================
; subroutine FADD
; add two floating point numbers
;
; input:   internal registers X2, X1, X0 and Y2, Y1, Y0 hold the
;          two floating point numbers to be added.
;
; output:  the result of Z = X + Y is saved in Z2, Z1, Z0.  The
;          addressible bit ZOV is set if the result is out of
;          range.
;
; calls:   ADD16
; destroys:     a, b, r2, r3, r4
;
;          addressible bit ZS is set if the sign of the operation is
;          negative.
;
;====================================================================
FADD:
     mov     a, X2         ; see if X=0
     jnz     fa_1
     mov     Z0, Y0
     mov     Z1, Y1
     mov     Z2, Y2
     ret
fa_1:
     mov     a, Y2         ; see if Y=0
     jnz     fa_2
     mov     Z0, X0
     mov     Z1, X1
     mov     Z2, X2
     ret
fa_2:
     mov     a, X2          ; get divisor exponent
     clr     C
     subb    a, Y2          ; subtract the exponents

     clr     YGX
     jnc     fa_3
     cpl     a
     inc     a
     set     YGX

fa_3:
     clr     C
     subb    a, #15         ; do exponents differ more than 15?
     jnc     fa_5

     jb      YGX, fa_4
     mov     Z0, X0
     mov     Z1, X1
     mov     Z2, X2
     ret
fa_4:
     mov     Z0, Y0
     mov     Z1, Y1
     mov     Z2, Y2
     ret


fa_5:
     mov     r7, a          ; save exponent difference

     mov     a, X1          ; get the sign bit plus 7 mantissa bits of X
     mov     C, acc.7       ; read sign bit
     mov     XS, C          ; save sign bit
     setb    acc.7          ; put the implied 1
     mov     X1, a          ; store mantissa with implied 1 restored

     mov     a, Y1          ; get the sign bit plus 7 mantissa bits of Y
     mov     C, acc.7       ; read sign bit
     mov     YS, C          ; save sign bit
     setb    acc.7          ; put the implied 1
     mov     Y1, a          ; store mantissa with implied 1 restored

     jb      XS, fa_7       ; next compute the sign of the result
     jb      YS, fa_6
     clr     ZS
     sjmp    fa_9
fa_6:
     setb    ZS
     sjmp    fa_5
fa_7:
     jb      YS, fa_8
     setb    ZS
     sjmp    fa_9
fa_8:
     clr     ZS

fa_9:


     jb      YGX, fa_6

fad_loop:
     clr     C
     mov     a, Y1
     rrc     a
     mov     Y1, a
     mov     a, Y0
     rrc     a
     mov     Y0, a
     djnz    r7, fad_loop




fa_6:






      org   0B000h

#include math.inc


; ====================================================
;
; end of program
