$mod51					; limited but usefull
$nolist					; no garbage please
$nosymbols				; wysiwyg
$include(c:\cet\inc\mymon.inc)		; for human interaction
$list
; these multi-byte precision math routines will do 1 to 4 bytes
; which equates from 8 to 32 bits. optimization could be achieved
; if a fixed precision is desired.
; with a 4 byte precision - you can divide 64 bits by 32 bits and
; multiply 32 bits by 32 bits with a 64 bit result 
; if you want any more bits, may i suggest floating point.
; included is a string to binary conversion for input and
; a display for any radix.
; any questions:email at greg@anest1.anest.ufl.edu
;
;
precision	equ	3		; precision in bytes
radbas		equ	10		; decimal display
;
; monitor routines
outt		equ	sndchr		; address of print screen routine
newline		equ	crlf		; send cr and lf to screen
;
; data storage
bytcnt		data	23h		; precision on the fly

; storage for addition and subtraction
msrc		equ	24h
mdst		equ	28h

; storage for multiplication
multiplier	equ	24h
product_hi	equ	24h
product_lo	equ	28h
multiplicand	equ	2ch

; storage for division - redundant addressing for readability
divisor		equ	24h
remainder	equ	28h
dividend_hi	equ	28h
dividend_lo	equ	2ch
quotient	equ	2ch

buff		equ	30h		; ascii input buffer

counter		data	4bh		; bit counter for shifts
saver		equ	4ch		; temporary storage
bitcnt		equ	4dh		; bit counter
altsav		equ	44h		; alternate saver


pushreg	macro	arg
	mov	a,arg
	push	acc
	endm

popreg	macro	arg
	pop	acc
	mov	arg,a
	endm

	org	tpa			; cpm diehard
start:	jmp	main

;
; move the address pointers to the least significant byte
asetup:	mov	a,r0
	add	a,bytcnt
	dec	a
	mov	r0,a
	mov	a,r1
	add	a,bytcnt
	dec	a
	mov	r1,a
	ret
;
; R0 has addr of value to negate
mbneg:	mov	r2,bytcnt
	mov	a,r0
	add	a,r2
	dec	a
	mov	r0,a
	setb	c		; 2's compliment
nv1:	mov	a,@r0
	cpl	a
	addc	a,#0
	mov	@r0,a
	dec	r0
	djnz	r2,nv1
	ret
;
; R0 has addr of value to shift left
mbsvl:	push	psw		; save carry
	mov	r2,bytcnt
	mov	a,r0
	add	a,r2
	dec	a
	mov	r0,a
	pop	psw		; get carry
mbsvl2:	mov	a,@r0
	rlc	a
	mov	@r0,a
	dec	r0
	djnz	r2,mbsvl2
	ret
;
; R0 has addr of value to shift right
mbsvr:	mov	r2,bytcnt
mbsvr2:	mov	a,@r0
	rrc	a
	mov	@r0,a
	inc	r0
	djnz	r2,mbsvr2
	ret
;
; R0 has addr of value to clear
mbclr:	mov	r2,bytcnt
mbclr2:	mov	@r0,#0
	inc	r0
	djnz	r2,mbclr2
	ret
;
; R0 has addr of value to save
mbsav:	mov	r2,bytcnt
	mov	r1,#saver
mbsav2:	mov	a,@r0
	mov	@r1,a
	inc	r1
	inc	r0
	djnz	r2,mbsav2
	ret
;
; R0 has addr of value to restore
mbrst:	mov	r2,bytcnt
	mov	r1,#saver
mbrst2:	mov	a,@r1
	mov	@r0,a
	inc	r0
	inc	r1
	djnz	r2,mbrst2
	ret
;
; R0 has addr of value to swap
mbswp:	mov	r2,bytcnt
	mov	r1,#saver
mbswp2:	mov	a,@r0
	xch	a,@r1
	mov	@r0,a
	inc	r0
	inc	r1
	djnz	r2,mbswp2
	ret
;
; R0 has addr of value to add carry to
mbadc:	push	psw		; save carry
	mov	r2,bytcnt
	mov	a,r0
	add	a,r2
	dec	a
	mov	r0,a
	pop	psw		; get carry
mbadc2:	mov	a,@r0
	addc	a,#0
	mov	@r0,a
	inc	r0
	djnz	r2,mbadc2
	ret
;
; multi-byte addition
; R0 has addr of source operand
; R1 has addr of destination operand
; destination = source + destination
;
mbadd:	call	asetup
	clr	c
	mov	r2,bytcnt
mbalup:	mov	a,@r0
	addc	a,@r1
	mov	@r1,a
	dec	r0
	dec	r1
	djnz	r2,mbalup
	ret
;
; multi-byte subtraction
; R0 has addr of source operand
; R1 has addr of destination operand
; destination = destination - source
;
mbsub:	call	asetup
	clr	c
	mov	r2,bytcnt
mbslup:	mov	a,@r1
	subb	a,@r0
	mov	@r1,a
	dec	r0
	dec	r1
	djnz	r2,mbslup
	ret
;
; move value pointed by R0 to addr pointed by R1
mbmov:	mov	r2,bytcnt
mbmv2:	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	djnz	r2,mbmv2
	ret
;
; multi-byte division

mbdiv:	mov	a,bytcnt	; # of bytes
	mov	b,#8		; times # of bits
	mul	ab
	mov	counter,a	; equals loop 
	clr	c		; no Q bit yet
mbdiv0:	mov	r0,#dividend_lo
	call	mbsvl		; paper and pencil method
	mov	r0,#dividend_hi
	call	mbsvl
	mov	r0,#divisor	; do a goesinta
	mov	r1,#dividend_hi
	call	mbsub		; dividend = dividend - divisor
	jnc	mbdiv2		; go if positive
	mov	r0,#divisor	; overflow
	mov	r1,#dividend_hi	; add back divisor
	call	mbadd		; dividend = dividend + divisor
	setb	c		; set Q = 0
mbdiv2:	cpl	c		; set Q = 1
	mov	r0,#dividend_lo
	call	mbadc		; set/reset Q bit
	djnz	counter,mbdiv0
	ret			; oh yes!
;
; multi-byte multiplication
;
mbmul:	mov	a,bytcnt		; get precision
	mov	b,#8
	mul	ab
	mov	counter,a		; bit counter
	mov	r0,#product_lo		; clear product
	call	mbclr
mbmul0:	clr	c
	mov	r0,#product_lo		; shift low partial product
	call	mbsvl
	mov	r0,#multiplier		; through high multiplier to carry
	call	mbsvl
	jnc	mbmul1
	mov	r0,#multiplicand	; add multiplicand
	mov	r1,#product_lo		; to product
	call	mbadd
	jnc	mbmul1
	mov	r0,#product_hi		; extend result
	call	mbadc
mbmul1:	djnz	counter,mbmul0		; do bits
	ret				; ta da !
;
$include(c:\cet\math\mbget.asm)		; ascii string to binary
;
$include(c:\cet\math\mbshow.asm)	; radix display routine
;
; examples
main:
	mov	a,#precision
	mov	bytcnt,a

; RPN like input where : = value 1, : = value 2, ? = command of + - * /
again:	call	getval		; get first value
	mov	r0,#product_lo
	mov	r1,#saver
	call	mbmov		; save first value
	call	getval		; get second value

	mov	a,#'?'
	call	outt
	call	getchr
	push	acc
	call	outt
	call	newline
	mov	r2,#8
separ:	mov	a,#'-'
	call	outt
	djnz	r2,separ
	call	newline
	pop	acc

	cjne	a,#'+',notadd
	mov	r0,#saver
	mov	r1,#mdst
	call	mbadd
	sjmp	addsub
	
notadd:	cjne	a,#'-',notsub
	mov	r0,#mdst
	mov	r1,#saver
	call	mbsub
addsub:	mov	r0,#saver
	call	mbshow
	jmp	alldun

notsub:	push	acc
	mov	r0,#mdst		; get second value
	mov	r1,#multiplier		; = divisor also
	call	mbmov
	mov	r0,#saver		; get first value 
	mov	r1,#multiplicand	; = dividend also
	call	mbmov
	pop	acc
		
	cjne	a,#'*',notmul
	call	mbmul	
	mov	r0,#product_hi
	mov	r2,bytcnt
smul1:	mov	a,@r0
	call	prtrad
	inc	r0
	djnz	r2,smul1
	mov	r0,#product_lo
	mov	r2,bytcnt
smul2:	mov	a,@r0
	call	prtrad
	inc	r0
	djnz	r2,smul2
	
	jmp	alldun

notmul:	cjne	a,#'/',alldun
	mov	r0,#dividend_hi
	call	mbclr
	call	mbdiv
	mov	r0,#remainder
	mov	r1,#altsav
	call	mbmov
	mov	r0,#quotient
	call	mbshow
	mov	a,#' '
	call	outt
	mov	r0,#altsav
	call	mbshow

alldun:	call	newline
	jmp	again		; my monitor has an ISR control-C break

	end
		
