$mod51
$nolist
$nosymbols
$INCLUDE (c:\cet\CONTROLS.INC)
$include(midi.inc)
$list
; thanks to davis@mail.sicd.etn.com:
;	A note on with velocity of 0 is basically a note off
;
	ORG	0000H		; Power on / RE_SET
	LJMP	START

	ORG	0003H		; trap functions
	ljmp	trapper

	ORG	000BH		; Timer 0 Overflow
	LJMP	badisr

	ORG	0013H		; External Interrupt 1 (pin 13)
	LJMP	badisr

	ORG	001BH		; Timer 1 Overflow
	LJMP	badisr

	ORG	0023H		; Serial Communications (TX and RX)
;	ljmp	rcvisr

badisr:	RETI			; Does nothing.
	org	30h

; function base of routines for trapper

	ljmp	inputt
	ljmp	outt
	ljmp	powr2

$include(niserial.asm)
;
; make a number between 0 and 7 a bit in byte
powr2:	inc	a		; make 0-7 become 1-8
	mov	r0,a		; counter
	setb	c		; prepare to rotate
	clr	a		; no bits yet
powr2a:	rlc	a		; make power of two
	djnz	r0,powr2a
	ret			; doit
;
$INCLUDE(c:\cet\mymon\TRAPPER.ASM)


$include (initchan.asm)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START:	MOV	SP,#4FH		; put stack out of way
	MOV	P2,#0		; data at page 0
	MOV	PSW,#0		; register bank 0
	call	idsrinit	; serial I/O
	call	inittrap	; trapper functions
	SETB    EA		; master enable
	call	init_channel	; get channel to use
	setb	runlite		; turn off command led

	mov	flags,#0	; all bit flags clear
	setb	psw.3		; reg bank 1
	mov	r0,#buffer	; init xmit head
	mov	r1,#buffer	; inti xmit tail
	clr	psw.3		; reg bank 0
	
	mov	b,#16
	mov	r0,#40
	clr	a
clrdat:	mov	@r0,a		; clear data
	inc	r0
	djnz	b,clrdat

;	mov	dptr,#lastcode
;clrpat:	clr	a
;	movx	@dptr,a
;	inc	dptr
;	mov	a,dph
;	cjne	a,#high bottom,clrpat
;	mov	a,dpl
;	cjne	a,#low bottom,clrpat

; address pointer for sysex to load code
	mov	nxtmem_lo,#low lastcode
	mov	nxtmem_hi,#high lastcode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main loop
next:	mov	a,#low next	; can't use goto... can't use goto...
	push	acc		; go here via ret instead of jmp (goto)
	mov	a,#high next	; a ret is 1 byte v.s. 2 or 3 byte jmp
	push	acc		; it could add up in 2k rom

	call	inputt		; get byte from midi
	jnb	loopthru,noout
	call	outt		; send
noout:	JNB	ACC.7,bdy1	; command byte ?
	mov	status,a	; save status byte
;
; check for sysex
	cjne	a,#0f0h,nosys
	clr	led8		; show we're in sysex
	call	system_exclusive
	setb	led8		; all done for now
	ret
;
; check for real time clock
nosys:	cjne	a,#0f8h,notick	; timing clock ?
	inc	beat
	mov	a,beat
	cjne	a,#12,nobeat	; half beat
	cpl	led8
	mov	beat,#0
nobeat:	ret
;
; check for system reset
notick:	cjne	a,#0ffh,norst	; system reset
	jmp	0		; this is easy enough
	
; if you think this is busy - look at machine code of c case statement
; I know this is off track (pun) but direct machine code "normally"
; executes about 10 times faster. The overhead of pushing and poping
; off the stack is heavy in c. Not that c is bad, just not for drivers.

norst:	mov	a,#low useit	; don't use goto...
	push	acc		; this lets stack remember where
	mov	a,#high useit	; to go instead of me.
	push	acc
	mov	function,#0	; null function
	mov	a,status	; get status
	anl	a,#0f0h		; mask command message
;
	cjne	a,#080h,not80	; note off
	mov	function,#2
	clr	onoff
	ret
;
not80:	cjne	a,#090h,not90	; note on
	mov	function,#2
	setb	onoff
	ret			; go and use it
;	
not90:	cjne	a,#0a0h,nota0	; Polyphonic aftertouch
	sjmp	ignore
;
nota0:	cjne	a,#0b0h,notb0	; Control change
	mov	function,#4
	ret			; go and use it
;
notb0:	cjne	a,#0c0h,notc0	; Program change
	mov	function,#6
	ret			; go and use it

notc0:	cjne	a,#0d0h,notd0	; Channel aftertouch
	sjmp	ignore

notd0:	cjne	a,#0e0h,ignore	; Pitch wheel range
	sjmp	ignore		; redundant but we might ??

ignore:	pop	acc		; raise stack, do NOT useit
	pop	acc
	ret			; goto next

useit:	mov	a,status	; get status byte again
	anl	a,#0fh		; get channel
	clr	ours		; not ours yet
	cjne	a,channel,notus	; not for us
	setb	ours		; its for us
	clr	nflag		; next byte will be note
notus:	ret			; goto next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; we are here after status byte has been parsed,
; aside from fact that the byte received has the
; high bit clear
;
bdy1:	jb	ours,bdy2	; its for us
	ret			; goto next
;
; after all that, we may actually have something to do
bdy2:	jb	nflag,velo	; on third byte
	mov	note,a		; save note
	mov	a,function
	cjne	a,#6,nochg
	sjmp	hearit		; program change has no third byte
nochg:	setb	nflag		; next byte will be velocity
	ret			; goto next
;
; possible to control triac dimmer with this
; but would require D/A port like 140L8
; I'm going to use 8255 to 3 triacs 

velo:	mov	velocity,a	; save velocity
	jnz	hearit
	clr	onoff		; 0 velocity is off
; also here for program change command C0
hearit:	clr	nflag		; next byte will be status or note
	mov	a,function	; 0,2,4,6,8...
	mov	dptr,#cmdtbl	; ajmp list
	jmp	@a+dptr
;
; absolute jumps to rom functions
cmdtbl:	ajmp	nothing		; 0 oops
	ajmp	toggle		; 2 lights
	ajmp	control		; 4 technique
	ajmp	program		; 6 reset
;
; Function 0, nothing
nothing:
	ret
;
; Function 2, note on/off
toggle:
	mov	a,#low doit
	push	acc
	mov	a,#high doit	; return from patch here
	push	acc
	mov	a,instrument
	anl	a,#7		; force to 8 from 0 through 7
	clr	c
	rlc	a		; * 2
	rlc	a		; * 4	ljmp & byte size
	mov	dptr,#instab	; ljmp list
	jmp	@a+dptr
;
doit:	mov	relay,a		; save for next time
	cpl	a		; low enable
	mov	p1,a		; logical to physical
	setb	onoff
	ret			; next
;
; Function 4
; status byte B0, Control change
control:
	mov	a,note		; get byte
	cjne	a,#7bh,notavl
	mov	p1,#0ffh	; all relays off
	setb	led8
	mov	relay,#0
notavl:	ret
;
; Function 6
; status byte C0, program change
program:
	mov	a,note
	cjne	a,#maxinst,chkhi
chkhi:	jnc	toohi
	mov	instrument,a
toohi:	ret
;
;========================================
$include (exclusiv.asm)		; system exclusive commands

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; instrument patches
	cseg at	500h
; long jumps to ram patches
instab:	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	ljmp	unused
	db	unsize
	
unused: mov	a,instrument		; show unused selection
	ret
unsize	equ	$-unused
;
lastcode	equ	$
bottom		equ	instab+512
	END

