$mod51
$include(settings.inc)
$nolist
;$nosymbols
$include(c:\cet\inc\controls.inc)
$include(c:\cet\inc\z80.inc)
$include(c:\cet\inc\float.inc)
$list
flags	equ	20h
range	bit	20h.0
filler	bit	20h.1
timrun	bit	20h.2
isbyte	bit	20h.3		; true if fill is a byte
havque	bit	20h.4		; multi-tasking enable
passall	bit	20h.7		; serial 8 bit passall

temp	equ	22h
;	and	23h

runlite	bit	p3.5

src	data	42h		; word , low byte first
dst	data	44h		; word
fil	data	46h		; word
radix	equ	48h		; current base
radsiz	equ	49h

strval	equ	30h		; for basex string (trashes input buffer)

pushreg	macro	arg
	mov	a,arg
	push	acc
	endm

popreg	macro	arg
	pop	acc
	mov	arg,a
	endm

	org	00h
	ljmp	start
	org	03h		; interrupt 0
	ljmp	badisr
	ljmp	kernal_exit
	db	0,0
	org	0Bh		; overflow 0
	ljmp	badisr	
	db	0,0,0,0,0
	org	13h		; interrupt 1
	ljmp	badisr
	db	0,0,0,0,0	
	org	1Bh		; overflow 1
	ljmp	badisr
	db	0,0,0,0,0	
	org	23h		; Serial
	ljmp	badisr
	db	0,0,0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		; 30h
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		; 40h
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		; 50h
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		; 60h
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		; 70h
	org	80h
	dseg
dmabuf:	ds	128
	cseg
	org	100h
funbas:				; function base for trapper
start:	ljmp	cold
	ljmp	warm
	ljmp	hot
	ljmp	getchr		; get char from serial
	ljmp	sndchr		; put char to serial
	ljmp	print		; print string in Dptr
	ljmp	ilprt		; print string in PC
	ljmp	prtrad		; print byte value
	ljmp	prtradw		; print word value
	ljmp	prtaddr		; print dptr
	ljmp	div32		; 32 bit divide
	ljmp	mul16		; 16 bit multiply
	ljmp	div16		; 16 bit divide
	ljmp	dvide8		; 8 bit divide
	ljmp	chkbrk		; control-c abort
	ljmp	crlf		; carriage return and linefeed
	ljmp	getln		; get line from serial
	ljmp	getaddr		; get word
	ljmp	basex		; print value in desired base
	ljmp	setint		; interrupt vector
	ljmp	insrt		; add function
	ljmp	tstop		; dst - dptr
	ljmp	psprad		; print space and byte
	ljmp	getrad		; get value in current radix
	ljmp	add16		; 16 bit add
	ljmp	sub16		; 16 bit subtract
	ljmp	badprm		; bad parameter return
	ljmp	prterr		; print error message and goto warm
	ljmp	instat		; serial input status
	ljmp	irhead		; serial rx head increment
	ljmp	powr2		; power of two
	ljmp	docmd		; do command table
	ljmp	forchr		; force character with no handshake
;
	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0
whereami	set $
	
	ORG	180H
cold:
	MOV	IE,#0			; disable ALL interrupts
	mov	sp,#4fh
	mov	psw,#0			; bank 0
	mov	p2,#0			; page 0

	mov	SCON,#52h		; initialize serial port
	mov	TMOD,#20h		; auto-reload timer 1
	mov	TH1,#0F3h		; 4800 baud (12.00 mHz clock)
	mov	pcon,#80h
	call	idsrinit		; serial rcvr/xmit isr
	setb	tr1			; start baud
	mov	radix,#16		; default radix is hex
	mov	radsiz,#2		; byte
	mov	flags,#0

	call	initport		; 8255 initialization

	if(traps=1)
	  call	inittrap		; int bios function
	else
	  if(test=1)
	    mov		a,#32h		; reti instruction
	    mov		dptr,#03h
	    movx	@dptr,a
	    mov		dptr,#0bh
	    movx	@dptr,a
	    mov		dptr,#13h
	    movx	@dptr,a
	    mov		dptr,#1bh
	    movx	@dptr,a
	  endif
	endif
	setb	ea			; start all interrupts
	call	crlf
	call	ilprt
	db	'Greg''s 8051 monitor',0
warm:	mov	sp,#4fh
	mov	psw,#0			; reg bank 0
	
hot:	mov	a,#low hot
	push	acc
	mov	a,#high hot
	push	acc
HOT2:	call	crlf
	mov	a,sp
	call	prtrad
	mov	a,#'>'
	call	sndchr
	call	getln
	jc	hot2
	call	parser
	jb	range,docmd
	mov	46h,44h
	mov	47h,45h
	mov	44h,42h
	mov	45h,43h

DOCMD:	mov	dptr,#table
JMPTBL:	mov	a,r2
	rl	a		; * 2
	inc	a
	movc	a,@a+dptr
	push	acc		; low byte
	mov	a,r2
	rl	a		; * 2
	movc	a,@a+dptr
	push	acc		; high byte
	ret			; doit
;
tilt:	mov	dptr,#goof
	sjmp	prterr
badcmd:	mov	dptr,#bcmd
	sjmp	prterr
badprm:	mov	dptr,#bprm
prterr:	call	print
	ajmp	warm
badisr:	reti

goof:	db	7,'You goofed.',0
bprm:	db	cr,lf,'BAD Parameter',0
bcmd:	db	cr,lf,'BAD Command',0
;
table:	dw	badcmd		;; @
	dw	PARMS		;; A	verify parameters
	dw	badcmd		;; B
	dw	CALLER		;; C	call address
	dw	INTMEM		;; D	internal memory
	dw	EDITMEM		;; E	edit memory
	dw	FIND		;; F	find value
	dw	GO		;; G	goto address
	dw	badcmd		;; H
	dw	INITRTC		;; I	real time clock initialize
	dw	SHOTIM		;; j	what time ii is
	dw	3000h		;; k	kermit receive file (3000h)
	dw	LOAD		;; L	hex loader
	dw	MOVE		;; M	move memory block
	dw	MATH		;; N	calculator (floating point)
	dw	SETTIM		;; O	set time of day
	dw	PORT		;; P	port I/O
	dw	QUIT		;; Q
	dw	REGDMP		;; R	register display
	dw	SFRDMP		;; S	sfr display
	dw	TYPEMEM		;; T	type text
	dw	WHATIS		;; U
	dw	SETINT		;; V	set int vector
	dw	Wipe		;; W	screen clear
	dw	DUMP		;; X	external memory
	dw	TESTER		;; Y	tester
	dw	SETRAD		;; Z	set radix to 2,8,10 or 16
	
;=========================================================
;  S U P P O R T
;=========================================================
if(loram=0)
; output a byte to serial line with handshake
outt:
$INCLUDE(SNDCHR.ASM)		; <###############
$INCLUDE(SERIAL.ASM)		; <###############
else
$include(polled.asm)
endif

$INCLUDE(PRTRAD.ASM)		; <###############

; get a byte from serial buffer
;getchr:	jnb	ri,getchr
;	mov	a,sbuf
;	anl	a,#7fh
;	clr	ri
;	ret

crlf:	mov	a,#cr
	call	sndchr
	mov	a,#lf
	jmp	sndchr
	

; print string pointed by dptr
print:	clr	a
	movc	a,@a+dptr
	jz	Rdun
	inc	dptr
	call	forchr		; force char with no handshake
	sjmp	print
Rdun:	ret

ilprt:	pop	dph
	pop	dpl
	call	print
X0254:	mov	a,#1
	jmp	@a+dptr

psprad:	push	acc
	mov	a,#20h
	call	sndchr
	pop	acc
	jmp	prtrad
;

PRTADDR:
	call	prtradw
	mov	a,#20h
	call	outt
	ret


;=========================================================
;  F U N C T I O N S
;=========================================================

;Address
$include(parms.asm)		; <###############
;D
$INCLUDE(INTMEM.ASM)		; <###############
; edit memory
;$include(editmem.asm)
;Find
$INCLUDE(FIND.ASM)		; <###############
GO:
CALLER:	push	42h
	push	43h
	ret
;K
$INCLUDE(CALC.ASM)		; <###############
;L
$INCLUDE(LOAD.ASM)		; <###############
;M
$INCLUDE(MOVE.ASM)		; <###############
;P
$INCLUDE(PORT.ASM)		; <###############
Quit:
	jmp	0
;Register dump
$INCLUDE(REGDMP.ASM)		; <###############
;Special function register dump
$INCLUDE(SFRDMP.ASM)		; <###############
;U
$INCLUDE(WHATIS.ASM)		; <###############
;V
$INCLUDE(SETINT.ASM)		; <###############
;Wipe screen
Wipe:	call	ilprt
	db	esc,'[H',esc,'[J',0
	ret
;X
$INCLUDE(DUMP.ASM)		; <###############
;Y
$INCLUDE(TESTER.ASM)		; <###############
;Z
$INCLUDE(SETRAD.ASM)		; <###############
$INCLUDE(GETRAD.ASM)		; <###############

$INCLUDE(INSERT.ASM)		; <###############

; check that ACC is between @ and Z
ckrange:
	clr	acc.5		; force upper
	cjne	a,#'[',cktohi
cktohi:	jnc	notrng
	cjne	a,#'@',cktolo
cktolo:	jc	notrng
	clr	c
	ret
notrng:	setb	c
	ret	

; make a number between 0 and 7 a bit in byte
powr2:	inc	a		; make 0-7 become 1-8
	mov	r0,a		; counter
	setb	c		; prepare to rotate
	clr	a		; no bits yet
pow2:	rlc	a		; make power of two
	djnz	r0,pow2
	ret			; doit

$INCLUDE(INPLN.ASM)		; <###############
$INCLUDE(GETADDR.ASM)		; <###############
$INCLUDE(HEXBIN.ASM)		; <###############
$INCLUDE(BASEX.ASM)		; <###############
$INCLUDE(PARSER.ASM)		; <###############
$INCLUDE(RTCISR.ASM)		; <###############
$INCLUDE(c:\cet\math\DIV32.ASM)		; <###############
$INCLUDE(c:\cet\math\DIV08.ASM)		; <###############
$INCLUDE(c:\cet\math\DIV16.ASM)		; <###############
$INCLUDE(c:\cet\math\MUL16.ASM)		; <###############
$INCLUDE(EDITMEM.ASM)		; <###############
$INCLUDE(TYPEMEM.ASM)		; <###############
$INCLUDE(SETTIM.ASM)		; <###############
add16:	clr	c			; clear for add
	mov	a,r6
	addc	a,r4			; add low
	mov	r6,a
	mov	a,r7
	addc	a,r5			; add high with carry
	mov	r7,a
	ret				; return high bit in carry

sub16:	clr	c			; clear for sub
	mov	a,r6
	subb	a,r4			; subtract low
	mov	r6,a
	mov	a,r7
	subb	a,r5			; subtract high with borrow
	mov	r7,a
	ret				; return high bit in carry
	if(traps=1)
$INCLUDE(TRAPPER.ASM)		; <###############
	endif


lastcode	equ	$
	end

