serial_vector	equ	0023h		; serial interrupt vector7
idsrinit:
; rcvr ring pointers
	mov	dptr,#rhead
	mov	a,#low rbuff
	movx	@dptr,a		; set rhead
	inc	dptr
	movx	@dptr,a		; set rtail
; xmit ring pointers
	mov	dptr,#xhead
	mov	a,#low xbuff
	movx	@dptr,a		; set xhead
	inc	dptr
	movx	@dptr,a		; set xtail

; set interrupt vector
	mov	dptr,#serial_vector
	mov	a,#02h		; ljmp opcode
	movx	@dptr,a
	inc	dptr
	mov	a,#high rcvisr	
	movx	@dptr,a
	inc	dptr
	mov	a,#low rcvisr
	movx	@dptr,a

	MOV     PCON,#80H	; double baud (divide by 16)
	MOV     SCON,#50H	; set up serial port
	MOV     TMOD,#20H	; set up timer 1 for baud generator
    	MOV	TH1,#0FEH	; 31250 baud
	SETB    TR1		; start timer

	setb	es		; enable serial R/X int
; all done (whew!)
	ret
;================================
inputt:	call	instat		; any characters ?
	jnc	inputt		; no, wait for one
	ret
; compare head to tail, get data if available
instat:	push	b
	push	dpl
	push	dph
	mov	dptr,#rtail
	movx	a,@dptr		; get rtail
	mov	b,a
	dec	dpl
	movx	a,@dptr		; get rhead
	cjne	a,b,havsum	; if not equal then data available
	clr	a
	clr	c
	sjmp	ist2
havsum:	mov	b,a		; save rhead value
	inc	a
	anl	a,#07fh		; 128 byte buffer
	movx	@dptr,a		; store new head
	mov	dpl,b		; dptr = buffer at head
	movx	a,@dptr		; get data
	setb	c		; tell human
ist2:	pop	dph
	pop	dpl
	pop	b
	ret
;================================
outt:	push	b
	push	dpl
	push	dph
	push	acc		; save data
	mov	dptr,#xtail
	movx	a,@dptr		; get tail
	mov	b,a		; save
	inc	a		; next position
	cjne	a,#xbufend,l489
	mov	a,#low xbuff
l489:	movx	@dptr,a		; store tail
	mov	dpl,b		; xbuff indexed
	pop	acc		; get data
	movx	@dptr,a		; store data
	jb	tflag,xmiton	; in progress ?
	setb	tflag
	setb	scon.1		; no, start
xmiton:	pop	dph
	pop	dpl
	pop	b
	ret
;================================
rcvisr:	push	psw
	push	dpl
	push	dph
	push	acc
	push	b
	jbc	scon.0,rcve
	jbc	scon.1,xmit
isrdun:	pop	b
	pop	acc
	pop	dph
	pop	dpl
	pop	psw
	reti
;
xmit:	mov	dptr,#xtail
	movx	a,@dptr		; get xtail
	mov	b,a		; save xtail
	dec	dpl		; point to xhead
	movx	a,@dptr		; get xhead
	cjne	a,b,xmore	; buffer empty ?
	clr	tflag		; flag all done
	sjmp	isrdun		; yes, done
xmore:	mov	b,a		; save xhead
	inc	a		; next byte
	cjne	a,#xbufend,xbok	; end of buffer ?
	mov	a,#low xbuff	; ring
xbok:	movx	@dptr,a		; new xhead
	mov	dpl,b		; xbuff indexed
	movx	a,@dptr		; get data
	mov	sbuf,a		; send it
	sjmp	isrdun
;
rcve:	mov	dptr,#rtail	; get low byte of buffer
	movx	a,@dptr		; get rtail
	mov	dpl,a		; dptr = buffer at tail
	mov	a,sbuf		; get input data
	movx	@dptr,a		; save data
	mov	a,dpl		; get rtail
	inc	a		; tail = tail + 1
	anl	a,#7fh		; ring 128 bytes
	mov	dpl,#low rtail	; point to rtail
	movx	@dptr,a		; store new tail value
	sjmp	isrdun

;128 byte ring buffer for receive
; 48 byte ring buffer for transmit
	  dseg	at 00700h
rbuff:	ds	128
rhead:	ds	1
rtail:	ds	1
;
xcode	equ	$
	dseg	at (xcode and 0fff0h) + 10h	; align on 16 byte boundary
xbuff:	ds	48
xbufend	equ	$ and 0ffh	; just the low byte
xhead:	ds	1
xtail:	ds	1
	cseg
	
