$mod51
$pagelength(52)
$nosymbols
$nolist
$include(c:\cet\inc\z80.inc)
$include(c:\cet\inc\controls.inc)
$include(c:\cet\inc\mymon.inc)
$include(c:\cet\inc\queue.inc)	; list of addresses
$list
	
; Since the queue info is all on one page these
; routines manipulate the low byte address only.
; Two byte calls for external access.

	cseg at	qu_base
	ajmp	inique		; initialize routine
	ajmp	timer_queue	; [timerq] batch - decrement tick counters
	ajmp	reschedule	; [slicer] switch to another task (exeque) 
	ajmp	insrtq		; addque - add a task to wait list
	ajmp	post_process	; remove task from execution list
	ajmp	scheduler	; run task
	ajmp	hibernate	; sleep
	db	quantim		; how long a job runs before sliced
	db	0
;	
querr:	setb	ea		; enable for serial
	jmp	ilprt
;
;=====================================================================
$include(inique.asm)		; initialize queue
;=====================================================================
$include(insque.asm)		; insert job
;=====================================================================
$include(getphd.asm)		; get process header
;=====================================================================
$include(remque.asm)		; remove queue at head
;=====================================================================
$include(insrtq.asm)		; insert queue at tail
;=====================================================================
$include(exeque.asm)		; slice routine
;=====================================================================
$include(initnode.asm)		; initialize node with sp, job # and ticks
;==========================================================================
$include(svpctx.asm)		; save internal ram
;==========================================================================
$include(ldpctx.asm)		; restore internal ram
;==========================================================================
$include(batchq.asm)		; batch timer queue
;=====================================================================
$include(hibern8.asm)		; hibernate

lastcode	set $
	dseg at	(lastcode and 0ff00h) + 100h
; all this data MUST be on the same 256 byte page else tilt
; a small sacrafice for effenciency. The dseg only
; insures a 16 byte boundary.
kernal_page:
FREE:	ds	1	; available job entries
WAIT:	ds	1	; jobs waiting to time out
EXEC:	ds	1	; jobs ready to be run
PAUS:	ds	1	; jobs waiting for resource
curjob:	ds	1	; current job that is running
ajobn:	ds	1	; bit list of available jobs
qflag:	ds	1	; queue status flags
	ds	7	; not used
retadr:	ds	2	; return address when stack overwritten
; a repeat macro would have been nice
QARRAY:	ds	quesiz
	ds	quesiz
	ds	quesiz
	ds	quesiz
	ds	quesiz
	ds	quesiz
	ds	quesiz
	ds	quesiz


	dseg at	(lastcode and 0ff00h) + 180h
CTXBAS:	ds	phdsiz * 8	; 8 process headers
ram_bottom	set $
	end

