; -----------------------------------------------------------------------------
; R-MASTER.asm      Last Update:06/22/92
;
; RS-485 network demo program 
;
; This routine emulates a PC network host (RS-485 host)
; by sending a single command.  The command and data
; bytes are defined by EQU pseudo-ops.  Change these to
; try different commands.  Run R-MASTER on one board and
; R-NET or R-SLAVEx on other node(s).
;
;
; Courtesy Rigel Corporation
;
; =============================================================================
;       m a i n    p r o g r a m
; -----------------------------------------------------------------------------
; port bits

  Dir485  equ P1.3  ; Dir485=0 for input, 1 for output
  Data485 equ P1.2  ; Data input/output

; -----------------------------------------------------------------------------
; data constants

  HERE    equ 0     ; master's address
  DestAdd equ 1     ; slave's address
  Cmd     equ 1     ; command
  Data    equ 0aah  ; data byte
  RsvByte equ 0     ; reserved byte

; -----------------------------------------------------------------------------

       org   8000h

ProgStart:                 ; program starts here

       clr   RI            ; flush serial input from host (RS-232)
       clr   Dir485        ; setup for input

loop0:
       jnb   RI, loop1     ; if a pending key from host (RS-232)...
       lcall getchr        ; ...read serial (RS-232) port...
       cjne  a, #3, loop1  ; ... check if a ctl-C...
       ljmp  0             ; ... if so jump to monitor via RESET
                           ; if no pending byte
loop1:
       mov   a, #DestAdd ; set up to transmit the destination address...
       lcall Sout        ; to slave (RS-485)...
       mov   a, #HERE    ; ... then the source address
       lcall Sout
       mov   a, #Cmd     ; ... then the command
       lcall Sout
       mov   a, #Data    ; ... then the data byte
       lcall Sout
       mov   a, #RsvByte ; ... and finally the reserved byte
       lcall Sout

;       lcall beep       ; beep is optional
       lcall print       ; print message to host (RS-232)
       db   "Message Sent...",0ah,0dh,0

       lcall sdelay     ; wait for 5 seconds for the slave(s) to...
       lcall sdelay     ; ... digest the message.
       lcall sdelay     ; << actually 5 seconds is far too long, but...
       lcall sdelay     ;  is convenient for debugging >>
       lcall sdelay

       ljmp  loop0      ; repeat over

; ====================================================
; include files

#include r-util.inc
#include r-net.inc

; ====================================================
;
; end of program
