; -----------------------------------------------------------------------------
; R-NET.asm      Last Update:06/22/92
;
; RS-485 network demo program for the prototyping board
;
;
; Courtesy Rigel Corporation 
;
; =============================================================================
;       m a i n    p r o g r a m
; -----------------------------------------------------------------------------
; port bits

  Dir485  equ P1.3  ; Dir485=0 for input, 1 for output
  Data485 equ P1.2  ; Data input/output

; -----------------------------------------------------------------------------

       org   8000h
ProgStart:          ; program starts here

       clr   RI     ; flush serial input
       clr   Dir485 ; setup for input

loop0:
       jnb   RI, loop2    ; if no receive interrupt, check network
       lcall getchr       ; else read char from RS-232 serial buffer
       cjne  a, #3, loop1 ; if not ctl-C go to loop1
       ljmp  0            ; else reset (to monitor)
loop1:
       push  acc          ; save char received from RS-232 (host)
       lcall print        ; print the following message to host
       db   "Key Pressed :   ", 0
       pop   acc          ; recall character
       push  acc
       lcall prthex       ; print as hex number

       pop   acc          ; recall character
       lcall Sout         ; send out from RS-485 port to network
;       lcall beep        ; beep is optional
       lcall print        ; print the following message to host
       db   "    Byte Sent...",0ah,0dh,0

loop2:
       jb    Data485, loop0 ; if no start bit at the RS-485 port goto loop0

       lcall Sin          ; else read the character from the RS-485 port
       push  acc          ; save character on stack
       lcall print        ; print the following message to host
       db   "Received: ", 0
       pop   acc          ; recall character from the RS=485 port (network)
       lcall prthex       ; print to host as a hex number
       lcall crlf         ; send a new line to host
       ljmp  loop0        ; repeat


; =============================================================================
; include files

#include r-util.inc
#include r-net.inc
; =============================================================================
;
; end of program
