; -----------------------------------------------------------------------------
; R-NETT.asm      Last Update:06/22/92
;
; network Transmit node
;
; RS-485 network demo program for the prototyping board.
;
; This routine continuously updates a byte count and sends it
; to the network.  It is used for debugging network bugs and
; checking for connections.
;
; Run R-NETT on one board, and R-NET on all the other
; (receiving) nodes
;
;
; Courtesy Rigel Corporation 
;
; =============================================================================
;       m a i n    p r o g r a m
; -----------------------------------------------------------------------------
; port bits

  Dir485  equ P1.3  ; Dir485=0 for input, 1 for output
  Data485 equ P1.2  ; Data input/output

; ----------------------------------------------------------------------------

       org   8000h

ProgStart:             ; program starts here
       clr   RI        ; flush serial input
       clr   Dir485    ; setup for input from RS-485 port
       mov   r7, #0    ; register 7 is a byte counter - initialize to 0
loop0:
       lcall inkey        ; see if a key is pressed on the host (RS-232)
       jz    loop1        ; if not branch to loop1
       cjne  a, #3, loop1 ; if a key is received see if it is ctl-C
       ljmp  0            ; if so return to monitor via RESET (0)
loop1:
       mov   a, r7        ; get byte count
       lcall prsphx       ; print byte count on host (RS-232)
       mov   a, r7        ; get byte count
       lcall Sout         ; send it to the network (RS-485)
       lcall print        ; print message on host (RS-232)
       db   "Byte Sent...",0ah,0dh,0
       inc   r7           ; update byte count - rolls over after 0FFh

       mov   a, #25       ; set up for a 25 millisecond delay
       lcall delay        ; give netork nodes to digest the message byte

       ljmp  loop0        ; repeat forever

; ====================================================
; include files

#include r-util.inc
#include r-net.inc

; ====================================================
;
; end of program
