$mod51
$nolist
$nosymbols
$include(c:\cet\inc\controls.inc)
$list
checksum	equ	6
runlite	bit	p3.5

	org	4000h
start:	mov	IE,#0			; all interrupts off
	mov	SP,#4Fh
	mov	psw,#0			; reg base 0
	mov	SCON,#52h		; initialize serial port
	mov	TMOD,#20h		; auto-reload timer 1
	mov	TH1,#0F3h		; 4800 baud (12mHz clock)
	mov	pcon,#80h
	setb	tr1			; start baud
	mov	dptr,#hello
	acall	print
	ljmp	main
;
; get a byte from serial line
inputt:	jnb	ri,inputt
	mov	a,sbuf
	anl	a,#7fh
	clr	ri
 	ret

crlf:	mov	a,#cr
	acall	sndchr
	mov	a,#lf
;
; output a byte to serial line
sndchr:	jnb	ti,sndchr
	clr	ti
	mov	sbuf,a
	ret

; print string pointed by dptr
print:	clr	a
	movc	a,@a+dptr
	jz	Rdun
	inc	dptr
	acall	sndchr
	sjmp	print
Rdun:	ret

prtaddr:
	mov	a,dph
	acall	prthex
	mov	a,dpl
	acall	prthex
	ret

PRTHEX:	push	2
	acall	BINHEX
	acall	sndchr
	mov	a,r2
	acall	sndchr
	pop	2
	RET

BINHEX:	mov	r2,a
	anl	a,#0fh
	add	a,#0f6h
	jnc	X029a
	add	a,#7
X029a:	add	a,#3ah
	xch	a,r2
	swap	a
	anl	a,#0fh
	add	a,#0f6h
	jnc	X02a6
	add	a,#7
X02a6:	add	a,#3ah
	ret



main:	clr	runlite			; runlite on
	acall	crlf
	mov	a,#'>'
	acall	sndchr
	acall	rhead			; start reader
halt:	cpl	runlite			; blink runlite
	mov	r0,#0
blinkr:	mov	r1,#0
	djnz	r1,$
	djnz	r0,blinkr
	ajmp	halt			; oops		
;		
rhead:	acall	inputt			; get a byte
	cjne	A,#':',rhead		; wait for a colon
	mov	checksum,#0		; zero checksum
	acall	bhex			; get # of bytes to load
	jz	endfl			; none to load
	mov	R2,A			; save byte count
	acall	tapehl			; get load address
; A has command byte
rloop:	acall	bhex			; get a byte of data
	movx	@dptr,A			; store data
	mov	00h,A			; save data
	movx	A,@DPTR			; get data just placed
	cjne	A,00h,halt		; error if not equal
	inc	DPTR			; next memory location
	djnz	R2,rloop		; do byte count
	acall	check			; check
	mov	a,#'.'			; show human
	acall	sndchr
	sjmp	rhead			; next line of data
;
tapehl:	acall	bhex
	mov	DPH,A			; hi byte load address
	acall	bhex			
	mov	DPL,A			; lo byte load address
;
bhex:	acall	hex			; get high nibble
	swap	A
	mov	R3,A			; save
	acall	hex			; get low nibble
	add	A,R3			; combine
	mov	R3,A			; save
	add	A,checksum		; add to checksum
	mov	checksum,A		; save checksum
	mov	A,R3			; restore byte
	ret
; get a hex value to A	
hex:	acall	inputt

; since the data is always valid, no error checking done
; if there was , what can we do about it, this is a boot loader
nib:	clr	c			; clear carry
	subb	A,#'0'			; subtract bias
	jnb	ACC.4,nib3		; if < 10
	subb	A,#7			; make A-F
nib3:	ret
;
check:	mov	r7,checksum
	acall	bhex			; get last byte which is checksum
	mov	b,a
	mov	a,checksum
	jz	ckok
	acall	crlf
	mov	a,#'?'
	acall	sndchr
	sjmp	error			; oops
ckok:	ret				; ok
;	
endfl:	acall	tapehl			; get start address
	mov 	R0,A			; save command
	acall	bhex			; get last checksum byte
	mov	A,R0
	cjne	A,#1,error
	ajmp	jpchl
error:	mov	a,#'E'
	acall	sndchr
	pop	acc
	pop	acc
	ajmp	halt
;
jpchl:
	acall	crlf
	mov	a,#'*'
	acall	sndchr
	ajmp	halt

hello:	db	cr,lf,'Reloader',cr,lf,0

	end

