if(queue=1)
$include(c:\cet\inc\queue.inc)
endif
hertz	equ	not 6250	; set for 160 hz with 12 mHz clock
tps	equ	160		; ticks per second

rtcisr:
	ipl_synch			; save psw & sfr's
;==============================
; GLP96048 increase accuracy by adding cpu delay to isr
	mov	a,tl0			; get cpu delay
	add	a,#low hertz+6		; 1 rate + lag to setup
	mov	tl0,a			; 1
	clr	a			; 1
	addc	a,#high hertz		; 1
	mov	th0,a			; 1
	setb	tr0			; 1 start timer again
;
	mov	dptr,#count
	movx	a,@dptr
	dec	a		; decrement second counter
	movx	@dptr,a
	jnz	rtckrnl
	mov	a,#tps		; 1/160
	movx	@dptr,a		; 1 second has elapsed
	call	clock		; do every second
	cpl	runlite
rtckrnl:
	if(queue=1)
	  jnb	havque,notimq
	  call	timerq		; decrement job ticks every 1/160
notimq:	  mov	dptr,#slit
	  movx	a,@dptr
	  dec	a
	  movx	@dptr,a
	  jnz	noslic		; not time yet for slicer
	  mov	a,#quantim
 	  movx	@dptr,a		; new job slice time
	  jnb	havque,noslic
	  call	slicer		; run jobs that are ready every 1/8
noslic:
	endif
;================================
kernal_exit:
	pop	dph
	pop	dpl
	pop	b
	pop	acc
	pop	psw
	setb	ea
	reti
;
dectim:	movx	a,@dptr
	add	a,#1		; time part
	da	a		; make BCD for display
	cjne	a,b,timok
	clr	a
timok:	movx	@dptr,a
	inc	dptr
	ret
;
clock:	mov	dptr,#second
	mov	b,#60h
	call	dectim		; seconds
	jnz	clkdun
	mov	b,#60h
	call	dectim		; minutes
	jnz	clkdun
	mov	b,#24h
	call	dectim		; hours
	jnz	clkdun
	mov	b,#30h
	call	dectim		; days
clkdun:	ret

$include(shotim.asm)

second:	db	0
minute:	db	0
hour:	db	0
day:	db	0
count:	db	0		; 160
impure	equ $
;================================
initrtc:
	jnb	timrun,irtc2	; if timer not running...
	call	ilprt
	db	7,'Clock is running.',0
	ret

irtc2:	anl	tcon,#0cfh	; 
	anl	tmod,#0f0h	; clear timer 0
	orl	tmod,#01h	; mode 1
	clr	havque
	if(queue=1)
	  call	inque		; initialize queue
	  jc	irtc3
	  setb	havque
irtc3:
	endif
	call	ilprt
	db	'Clear clock (Y/N) ? ',0
	call	getchr
	clr	acc.5		; force upper
	cjne	a,#'Y',noclrc
	clr	a
	mov	dptr,#second
	mov	b,#4
	clr	a
clrtim:	movx	@dptr,a		; reset clock
	inc	dptr
	djnz	b,clrtim
noclrc:	mov	dptr,#count	; point to count
	mov	a,#tps
	movx	@dptr,a		; a second
	mov	dptr,#rtcisr
	mov	a,#0bh
	call	setint
	setb	pt0		; high priority timer 0
	mov	tl0,#low hertz
	mov	th0,#high hertz
	setb	tr0		; timer run
	orl	ie,#82h
	lcall	ilprt
	db	'RTC activated.',cr,lf,0
	setb	timrun
	ret

