
; "C" runtime library
;
; ascii hex to binary - assumes valid characters 0-9 & a-f or A-F 
nib:	clr	c			; clear carry
	subb	A,#'0'			; subtract bias
	jnb	ACC.4,nib3		; if < 10
	subb	A,#7			; make A-F
	clr	acc.5			; force uppercase
nib3:	ret

; Print string.
; a back slash '\' signals a 2 byte hex value follows
; This allows delimiters to be passed: ' !%&' and 
; control chars like cr & lf
printf:	clr	f0
pf1:	movx	a,@dptr
	inc	dptr
	jz	pfd		; end of string
	jb	f0,pf2		; hex byte active
	cjne	a,#'\',pf5
	setb	f0		; flag hex conversion
	mov	val,#0		; initialize result
	sjmp	pf1		; get value
pf2:	call	nib		; make binary
	xch	a,val
	jz	pf3		; first byte
	swap	a		; * 4
	anl	a,#0f0h		; clear first flag
	clr	f0		; no more hex
pf3:	orl	a,val
	setb	acc.7
	mov	val,a
	jb	f0,pf1		; more hex value
	anl	a,#7fh
pf5:	call	sndchr
	sjmp	pf1
pfd:	ret
;
; add contents of ACC to word2
addw2:	add	a,w2l
	mov	w2l,a
	jnc	$+3
	inc	w2h
	ret
;
; subtract contents of ACC to word2
subw2:	clr	c
	xch	a,w2l	; a = subtrahend
	subb	a,w2l
	mov	w2l,a
	jnc	$+3
	dec	w2h
	ret
;
; for/next loop save return address for when condition fails
; and goto condition check via return
donext:	pop	w2h
	pop	w2l
	lxd	retadr,word2	; save return if condition fails
	ret			; goto condition check
;
; add A to DPTR
addptr:	add	a,dpl		;add the acc to dpl
	mov	dpl,a		;put it in dpl
	jnc	$+4		;jump if no carry
	inc	dph		;bump dph
	ret			;exit
;
; shift word2 left b times					*
shift_left:	
	mov	a,w2h
	mov	c,acc.7
	push	psw		; save sign
	mov	a,b
	jz	noleft
	clr	c
sllup:	mov	r0,#word2
	call	mbsvl
	djnz	b,sllup
noleft:	pop	psw
	mov	a,w2h
	mov	acc.7,c		; set sign
	mov	w2h,a
	ret
;
; shift word2 right b times
shift_right:	
	mov	a,w2h
	mov	c,acc.7		; get sign
	push	psw
	mov	r2,#2
	mov	r0,#word2
	mov	a,b
	jz	norite
srlup:	pushreg	r0
	call	mbsvr
	popreg	r0
	djnz	b,srlup
norite:	pop	psw
	mov	a,w2h
	mov	acc.7,c		; set sign
	mov	w2h,a
	ret
;
; input: word2 has index, dptr has array base
; output: dptr is addr of indexed array, r2 has byte count
indexer:
	inc	dptr		; past type
	movx	a,@dptr		; class = size
	mov	b,a
	mov	r0,#word1
	inc	dptr		; past class
	inc	dptr		; past hi size
	inc	dptr		; past lo size
	call	rtldi		; word1 = array base
; multiply index by size
	clr	c
	mov	a,b
	rrc	a		; / 2
	mov	r3,a		; shift count
	clr	c
idxr1:	mov	r0,#word2
	mov	r2,b		; byte count 
	call	mbsvl		; *2 for word, *4 for long
	djnz	r3,idxr1
; add base to index
idxr2:	mov	r0,#word2	; index * size
	mov	r1,#word1	; array base
	mov	r2,b		; byte count
	call	mbadd		; word1 has result
; return in dptr
	mov	dph,w1h
	mov	dpl,w1l
	mov	r2,b		; return with byte count
	ret
;
; negate word1
negw1:	mov	r0,#word1
	sjmp	negwrd
;
; negate word2
negw2:
	mov	r0,#word2
negwrd:	mov	r1,#2
	jmp	negate
;
; r4/r5/r6/r7 = dptr * dptr
square:	mov	r4,dpl
	mov	r5,dph
	mov	r6,dpl
	mov	r7,dph
	call	mul16
	ret
;
; push data pointed by R0 to runtime stack - byte count 
; R2 has byte count
; dptr saved
rtpush:	push	dpl
	push	dph
	clr	c
	mov	a,stkptr+1	; low
	subb	a,r2
	mov	dpl,a
	mov	a,stkptr	; high
	subb	a,#0
	mov	dph,a
	mov	stkptr,dph
	mov	stkptr+1,dpl
rtpushlup:
	mov	a,@r0
	movx	@dptr,a
	inc	dptr
	inc	r0
	djnz	r2,rtpushlup	
	pop	dph
	pop	dpl
	ret
;
; pop data pointed by R0 from runtime stack
; R2 has byte count
; dptr saved
rtpop:	push	dpl
	push	dph
	mov	dph,stkptr
	mov	dpl,stkptr+1
	clr	c
	mov	a,stkptr+1	; low
	addc	a,r2
	mov	stkptr+1,a
	mov	a,stkptr	; high
	addc	a,#0
	mov	stkptr,a
rtpoplup:
	movx	a,@dptr
	mov	@r0,a
	inc	dptr
	inc	r0
	djnz	r2,rtpoplup
	pop	dph
	pop	dpl
	ret
;
; print internal value pointed by R0, r2 has byte count
prtval:
pval1:	mov	a,@r0
	call	prtrad
	inc	r0
	djnz	r2,pval1
	ret
;
; move word in r1 and word in r2 to long in r0
wtl_expand:
	mov	a,@r1
	dec	r1
	mov	@r0,a		; byte 4
	dec	r0
	mov	a,@r1
	mov	@r0,a		; byte 3
	dec	r0
	mov	a,r2
	mov	r1,a
	mov	a,@r1
	dec	r1
	mov	@r0,a		; byte 2
	dec	r0
	mov	a,@r1
	mov	@r0,a		; byte 1
	ret
;
ltw_reduce:
	mov	a,@r0		; byte 1
	mov	@r1,a
	inc	r0
	inc	r1
	mov	a,@r0		; byte 2
	mov	@r1,a
	inc	r0
	mov	a,r2
	mov	r1,a
	mov	a,@r0		; byte 3
	mov	@r1,a
	inc	r0
	inc	r1
	mov	a,@r0		; byte 4
	mov	@r1,a
	ret	
;
; dptr = addr of indexed array, get data to long2
get_cell_l:
	mov	r0,#long2
	mov	r2,#4
gcl2:	movx	@dptr,a
	mov	@r0,a
	inc	dptr
	inc	r0
	djnz	r2,gcl2
	ret

; dptr = addr of indexed array, long2 has data
put_cell_l:
	mov	r0,#long2
	mov	r2,#4
pcl2:	mov	a,@r0
	movx	@dptr,a
	inc	dptr
	inc	r0
	djnz	r2,pcl2
	ret
;
rtldx:	movx	a,@dptr
	mov	r2,a		; byte count
	inc	dptr		; past type
	inc	dptr		; past class
	inc	dptr		; past hi size
	inc	dptr		; past lo size
rtldx2:	movx	a,@dptr
	mov	@r0,a
	inc	dptr
	inc	r0
	djnz	r2,rtldx2
	ret
;
rtaxi:	movx	a,@dptr			; type is size
	mov	r2,a
	mov	r0,#word1
	mov	r1,#word2
	jmp	mbadd			; @r1 = word1 + word2
;
rtlxd:	movx	a,@dptr		; get byte count
	mov	r2,a
	inc	dptr		; past type
	inc	dptr		; past class
	inc	dptr		; past hi size
	inc	dptr		; past lo size
rtlxd2:	mov	a,@r0		; get internal byte
	movx	@dptr,a		; put external byte
	inc	dptr
	inc	r0
	djnz	r2,rtlxd2
	ret
;
rtldd:	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	djnz	r2,rtldd
	ret
;
rtisub:	mov	r0,#word1
	mov	r1,#word2
	mov	r2,#2		; force word
	jmp	mbsub		; word2 = word2 - word1
;
rtiadd:	mov	r0,#word1
	mov	r1,#word2
	mov	r2,#2		; force word
	jmp	mbadd		; word2 = word2 + word1
;
rtand:	mov	r0,#word1
	mov	r1,#word2
	mov	r2,#2
	jmp	mband
;
; compare internal word1 to internal word2
rtcmp:	mov	r0,#word1
	mov	r1,#word2
	mov	r2,#2
	jmp	mbcmp
;
; add word constant to internal value
rtadi:	inc	r0
	mov	a,@r0	; lo
	add	a,dpl
	mov	@r0,a
	dec	r0
	mov	a,@r0	; hi
	addc	a,dph
	mov	@r0,a
	ret
;
; subtract constant to internal value
rtsdi:	clr	c
	inc	r0
	mov	a,@r0	; lo
	subb	a,dpl
	mov	@r0,a
	dec	r0
	mov	a,@r0	; hi
	subb	a,dph
	mov	@r0,a
	ret
;
; load internal value referenced by R0 with constant in dptr
rtldi:	mov	@r0,dph
	inc	r0
	mov	@r0,dpl
	ret

