$mod51
$nosymbols
$nolist
$include(c:\cet\inc\controls.inc)
$include(c:\cet\inc\mymon.inc)
$include(c:\cet\inc\z80.inc)
$include(c:\cet\inc\emath.inc)
$list

vector	equ	29		; 4014 vector mode
alpha	equ	31		; 4014 text mode
center	equ	384		; center baseline
toplin	equ	640 - 1
botlin	equ	128 + 1
buff	equ	6000h		; 1k buffer 
samples	equ	not 1000
mode	bit	21h.0
ready	bit	21h.1
button	bit	21h.2
face	bit	21h.3
temp	equ	22h
rnsl	equ	23h		; random seed
filter	equ	26h		; &27
NUMER	EQU	28H		; &29
DENOM	EQU	2AH		; &2b

volt	data	4dh
rate	data	4eh
;	and	4fh

	org	5000h
	JMP	START
; interrupt service routine for A/D sampler
t0isr:	jb	int1,t0isr	; wait for conversion
	movx	a,@r0		; read
	jnb	mode,short
	mov	th0,rate
	mov	tl0,rate+1
	setb	tr0
short:	movx	@r0,a		; start another sample
	movx	@dptr,a		; store
	inc	dptr
	mov	a,dph
	anl	a,#high buff + 3	; don't allow overrun
	mov	dph,a
	anl	a,#3
	orl	a,dpl		; we done ?
	jnz	more		; nope
	setb	ready		; yup, tell human
	clr	ex0		; stop
more:	reti

start:	clr	ea
;	mov	numer,#0
;	mov	numer+1,#48
;	mov	denom,#0
;	mov	denom+1,#49
	clr	button		; filter off
	setb	face		; grid lines on
	mov	dptr,#p8255
	mov	a,#080h		; port C output
	movx	@dptr,a
	dec	dpl		; point to p6
	mov	a,#0ffh		; 0-5 volt scale = 1.25/div
	movx	@dptr,a
	mov	rate,#high not 1000	; horz = .1s/div
	mov	rate+1,#low not 1000
	mov	filter,#0
	mov	dptr,#center
	shld	basel
	mov	volt,#0		; vert = 1.25v/div
; timer 0 used for sweep data sampler
	mov	dptr,#0bh	; timer 0 interrupt vector address
	mov	a,#2		; ljmp
	movx	@dptr,a
	inc	dptr
	mov	a,#high t0isr
	movx	@dptr,a
	inc	dptr
	mov	a,#low t0isr
	movx	@dptr,a
	setb	ea
	call	initgraf
	jmp	main
;
; sample a/d data
SAMPLER:
	clr	ready		; nothing yet
	clr	ea
	anl	tcon,#0cfh	; timer 0 off
	anl	tmod,#0f0h	; clear timer 0
	jb	mode,longer
	orl	tmod,#02h	; mode 2 - auto-reload
	sjmp	setth0
longer:	orl	tmod,#01h	; mode 1 - 16 bit
	mov	tl0,rate+1
setth0:	mov	th0,rate
	mov	dptr,#buff	; where to put data
	mov	p2,#high AD0	; where to get data
	mov	r0,#0
	orl	ie,#82h		; enable interupts
	setb	tr0		; run
wfr:	jnb	ready,wfr	; twiddle thumbs for 1/10 second
	clr	tr0
	ret
	
show_data:
	mov	dptr,#buff		; where sampled data is
	shld	head
	movx	a,@dptr
	mov	filter,a		; start folpf at first byte
	mov	dptr,#samples
	shld	sampl			; number of data points
	acall	initgraf
	jnb	face,noface
	acall	faceplate
noface:
; show where baseline is
	mov	dptr,#0
	shld	x1
	shld	x2
	lhld	basel
	clr	c
	mov	a,dpl
	subb	a,#8
	mov	dpl,a
	mov	a,dph
	subb	a,#0
	mov	dph,a
	shld	y1
	shld	y2
	call	dot
	call	ilprt
	db	alpha,'>',0
; setup first data position
	lhld	basel
	shld	y1
	shld	y2
	mov	dptr,#10
	shld	x1
	shld	x2
	acall	plot			; start at baseline
	acall	savit
;========================================
wave:	mov	p2,#high x1
	mov	r0,#low x1+1
	movx	a,@r0
	add	a,#1		; x1 = x1 + 1
	movx	@r0,a
	dec	r0
	movx	a,@r0
	addc	a,#0
	movx	@r0,a
	call	chkbrk		; quitter ?
	jnc	nokeyb
	ret
nokeyb:	lhld	head		; buffer pointer
	movx	a,@dptr		; get data
	push	acc		; save data
	inc	dptr
	shld	head
	pop	acc		; get data	
	jnb	button,olpf
	call	folpf		; first order low pass filter
	mov	a,filter
olpf:	PUSH	ACC
	lhld	basel
	POP	ACC
	mov	p2,#high y1	; put in Y1
	mov	r0,#low y1+1
	add	a,dpl
	movx	@r0,a		; y1 = data
	dec	r0		; to high byte of y1	
	clr	a		; hi y always 0
	addc	a,dph
	movx	@r0,a		; y1 = data
	LHLD	Y1
; dont allow data above top 
	clr	c
	mov	a,dpl
	subb	a,#low toplin
	mov	a,dph
	subb	a,#high toplin
	jc	dataok
	mov	dptr,#640	; stop at top
	shld	y1
dataok:	acall	line		; draw it	
	acall	savit
	lhld	sampl
	inc	dptr		; next sample
	shld	sampl
	mov	a,dpl
	orl	a,dph		; done ?
	jz	alldone
	ljmp	wave
;========================================
alldone:
; show horizontal time per division
	mov	r2,#0		; row
	mov	r3,#0		; col
	acall	set_cursor
	call	show_rate

	call	show_vert
	
; show filter toggle
	mov	r2,#0		; row
	mov	r3,#37		; col
	acall	set_cursor
	call	show_filter
;
; show mode toggle
	mov	r2,#1		; row
	mov	r3,#37		; col
	acall	set_cursor
	call	show_mode

	ret
;
KEYHIT:	mov	b,a		; save keystroke
	call	irhead
	mov	dptr,#keytabl
nxttab:	movx	a,@dptr
	inc	dptr
	cjne	a,#0ffh,notend
	mov	a,#7
	call	sndchr		; invalid key
	sjmp	novkey
notend:	cjne	a,b,notit
	movx	a,@dptr
	jmp	@a+dptr
notit:	inc	dptr
	sjmp	nxttab
novkey:	ret	

main:	mov	r2,#21
	mov	r3,#0
	acall	set_cursor
	call	ilprt
	db	alpha,'$',0
nokeys:	call	chkbrk
	jnc	nokeys
	call	keyhit
	jmp	main
			
; table of valid keys, the completion routines must follow
; the offset limit is 255 bytes from here
keytabl:
	db	' ',short_main-$
	db	'+',short_base-$
	db	'-',short_base-$
	db	'D',short_show-$
	db	'F',short_fltr-$
	db	'G',short_grid-$
	db	'H',short_help-$
	db	'X',short_EXIT-$
	db	'S',get_samples-$
; HORIZONTAL TIME SETTINGS
	db	'0',short_time-$
	db	'1',short_time-$
	db	'2',short_time-$
	db	'3',short_time-$
	db	'4',short_time-$
	db	'5',short_time-$
	db	'6',short_time-$
	db	'7',short_time-$
; VERTICAL VOLTAGE SETTINGS
	db	'Q',short_volt-$	;  5v
	db	'W',short_volt-$	;  2v
	db	'E',short_volt-$	;  1v
	db	'R',short_volt-$	; .5v
	db	'T',short_volt-$	; .2v
	db	'Y',short_volt-$	; .1v
	db	0ffh
;================================
get_samples:
	mov	a,#'.'
	call	sndchr
	call	sampler
	mov	a,#'.'
	call	sndchr
	ret
;
short_grid:
	cpl	face		; grid line on/off
	ret
;
short_fltr:
	cpl	button		; folpf on/off
	ret
;	
short_time:
	jmp	set_horz
;
short_volt:
	jmp	set_vert
;
short_exit:
	pop	acc	; raise stack
	pop	acc
	jmp	hot
;
short_show:
	jmp	show_data
;	
short_main:
	ret
;
short_help:
	jmp	show_help
;
short_base:
	jmp	baseline

;================================
$include(baseline.asm)
;
show_help:
	mov	r2,#0
	mov	r3,#0
	acall	set_cursor
	mov	dptr,#hlpmsg
shohlp:	movx	a,@dptr
	jz	shdun
	call	sndchr
	call	wait_a_bit
	inc	dptr
	sjmp	shohlp
shdun:	ret
		
$include(hlpmsg.asm)
;
WAIT_A_BIT:
	MOV	R0,#20H
PAWS:	MOV	R1,#0
	DJNZ	R1,$
	DJNZ	R0,PAWS
	RET
;
$include(set_horz.asm)
;
$include(set_vert.asm)
;
show_rate:
	mov	a,#alpha
	call	sndchr
	call	ilprt
	db	'Horz div: ',0
	mov	r7,rate
	mov	r6,rate+1
	neghl
	mov	r0,#30h		; buff
	mov	r1,#5		; size
	mov	r2,#10		; radix
	call	basex
	mov	r0,#30h
	mov	a,@r0
	cjne	a,#'1',nt5
	call	sndchr
nt5:	mov	a,#'.'
	call	sndchr
	mov	b,#3
just3:	inc	r0
	mov	a,@r0
	call	sndchr
	djnz	b,just3
	mov	a,#'s'
	call	sndchr
	RET
;
show_filter:
	call	ilprt
	db	alpha,'Filter: o',0
	jb	button,fion
	call	ilprt
	db	'ff',0
	sjmp	ovron1
fion:	mov	a,#'n'
	call	sndchr
ovron1:	ret
;
show_mode:
	call	ilprt
	db	alpha,'Mode  : o',0
	jb	mode,mion
	call	ilprt
	db	'ff',0
	sjmp	ovron2
mion:	mov	a,#'n'
	call	sndchr
ovron2:	ret
;			
$include(c:\cet\plot.asm)

$include(faceplat.asm)

$include(c:\cet\folpf.asm)

pertab:
p005:	dw	not 50		; .005
p010:	dw	not 100		; .01
p020:	dw	not 200		; .02
p050:	dw	not 500		; .05
p100:	dw	not 1000	; .1
p200:	dw	not 2000	; .2
p500:	dw	not 5000	; .5
p1000:	dw	not 10000	; 1
p2000:	dw	not 20000	; 2

lastcode	equ	$
	dseg at (lastcode and 0ff00h)+100h
ram:
x1:	ds	2
y1:	ds	2
x2:	ds	2
y2:	ds	2
head:	ds	2
sampl:	ds	2
xlin:	ds	2
ylin:	ds	2
basel:	ds	2
	end

