serial	equ	0023h		; serial interrupt vector
tflag	equ	1		; serial transmit busy 

idsrinit:
; rcvr ring pointers
	mov	dptr,#rhead
	mov	a,#low rbuff
	movx	@dptr,a		; set rhead
	inc	dptr
	movx	@dptr,a		; set rtail

; xmit ring pointers
	mov	dptr,#xhead
	mov	a,#low xbuff
	movx	@dptr,a		; set xhead
	inc	dptr
	movx	@dptr,a		; set xtail

; status flags
	mov	dptr,#sflag
	clr	a
	movx	@dptr,a
	
; set interrupt vector
	mov	dptr,#serial
	mov	a,#02h		; ljmp instruction
	movx	@dptr,a
	inc	dptr
	mov	a,#high rcvisr	
	movx	@dptr,a
	inc	dptr
	mov	a,#low rcvisr
	movx	@dptr,a

	setb	es		; enable serial R/X int
; all done (whew!)
	ret
;================================
getchr:	call	instat		; any characters ?
	jnc	getchr		; no, wait for one
	jmp	irhead		; increment head
;================================
; compare head to tail, get data if available, check for break
instat:	push	b
	push	dpl
	push	dph
	mov	dptr,#rhead	; get stationary head
	movx	a,@dptr
	mov	b,a		; save head pointer
	inc	dptr
	movx	a,@dptr		; get variable tail
	cjne	a,b,havsum	; if not equal then data available
	clr	a
	clr	c
	jmp	ist2
havsum:	mov	dpl,b		; dptr = buffer at head
	movx	a,@dptr		; get data
	jb	passall,brknot
	cjne	a,#3,brknot
	call	irhead		; remove break from buff
	call	ilprt
	db	cr,lf,'<Break>',0
	jmp	warm
brknot:	setb	c		; flag have one
ist2:	pop	dph
	pop	dpl
	pop	b
	ret
;================================
; increment head pointer
irhead:	push	acc
	push	dpl
	push	dph
	mov	dptr,#rhead
	movx	a,@dptr		; get head pointer
	inc	a		; head = head + 1
	anl	a,#07fh		; 128 byte buffer
	movx	@dptr,a		; store new head
	pop	dph
	pop	dpl
	pop	acc
	ret
;===============================
;for older programs, this is done in instat
CHKBRK:	jmp	instat		; check for break
;
rcvisr:	clr	ea
	push	psw
	push	dpl
	push	dph
	push	acc
	push	b
	jbc	scon.0,rcve
	jbc	scon.1,xmit
isrdun:	pop	b
	pop	acc
	pop	dph
	pop	dpl
	pop	psw
	setb	ea
	reti
;
rcve:	mov	dptr,#rtail	; get low byte of buffer
	movx	a,@dptr		; get rtail
	mov	dpl,a		; dptr = buffer at tail
	mov	a,sbuf		; get input data
	movx	@dptr,a		; save data
	mov	a,dpl		; get rtail
	inc	a		; tail = tail + 1
	anl	a,#7fh		; ring 128 bytes
	mov	dpl,#low rtail	; point to rtail
	movx	@dptr,a		; store new tail value
	jbc	scon.1,xmit	; just in case xmit also
	sjmp	isrdun
;
xmit:	mov	dptr,#xtail
	movx	a,@dptr		; get xtail
	mov	b,a		; save xtail
	dec	dpl		; point to xhead
	movx	a,@dptr		; get xhead
	cjne	a,b,xmore	; buffer empty ?
	dec	dpl		; point to sflag
	movx	a,@dptr
	clr	acc.tflag	; flag all done
	movx	@dptr,a
	sjmp	isrdun		; yes, done

xmore:	mov	dpl,a		; xbuff indexed at head
	movx	a,@dptr		; get data from head
	mov	sbuf,a		; send it
	mov	a,dpl		; get xhead
	inc	a		; next byte
	anl	a,#03fh		; ring 64 bytes
	setb	acc.7		; always 80 above
	mov	dpl,#low xhead
	movx	@dptr,a		; new xhead
	sjmp	isrdun

;128 byte ring buffer for receive
; 64 byte ring buffer for transmit
	  dseg at 1700h
rbuff:	ds	128
xbuff:	ds	64
rhead:	ds	1
rtail:	ds	1
sflag:	ds	1
xhead:	ds	1
xtail:	ds	1
	cseg

