$MOD51
; r0 & r1 are index registers
; dptr is free

Creg	equ	R2
Breg	equ	R3
Ereg	equ	R4
Dreg	equ	R5
Lreg	equ	R6
Hreg	equ	R7

bc	equ	R2
de	equ	R4
hl	equ	R6

;p2/r0	= source
;dptr	= destination
;b	= count

LDIR	macro
	movx	a,@r0
	movx	@dptr,a
	inc	r0
	inc	dptr
	djnz	b,$-4		;; this eliminates local labels
	endm

lxibc	macro	addr
	mov	r2,#low addr
	mov	r3,#high addr
	endm
lxide	macro	addr
	mov	r4,#low addr
	mov	r5,#high addr
	endm
lxihl	macro	addr
	mov	r6,#low addr
	mov	r7,#high addr
	endm

; add BC to HL
dadb0 set 0
DADB	macro
	if (dadb0=0)
	sjmp	dadb2
dadb1:	xch	a,r6		; HL = HL + BC
	add	a,r2
	xch	a,r6
	xch	a,r7
	addc	a,r3
	xch	a,r7
	ret
dadb0 set 1
dadb2:
	endif
	acall	dadb1
	endm

dadd0 set 0	
DADD	macro			; checked 950720
	if (dadd0=0)
	sjmp	dadd2
dadd1:	xch	a,r6		; HL = HL + DE
	add	a,r4
	xch	a,r6
	xch	a,r7
	addc	a,r5
	xch	a,r7
	ret
dadd0 set 1
dadd2:
	endif
	acall	dadd1
	endm

dadh0 set 0	
DADH	macro			; checked 950720
	if(dadh0=0)
	sjmp	dadh2
dadh1:	clr	c
	xch	a,r6		; HL = HL + HL
	rlc	a
	xch	a,r6
	xch	a,r7
	rlc	a
	xch	a,r7
	ret
dadh0 set 1
dadh2:
	endif
	acall	dadh1
	endm
		
DI	macro
	clr	ea
	endm

EI	macro
	setb	ea
	endm

EXX	macro
	xrl	psw,#08h		; toggle bank 0 / 1
	endm

LBCD	MACRO	addr
	MOV	R0,#LOW ADDR
	MOV	P2,#HIGH ADDR
	MOVX	A,@R0
	MOV	r2,A
	INC	R0
	MOVX	a,@R0
	MOV	r3,A
	ENDM

LDED	MACRO	addr
	MOV	R0,#LOW ADDR
	MOV	P2,#HIGH ADDR
	MOVX	A,@R0
	MOV	r4,A
	INC	R0
	MOVX	a,@R0
	MOV	r5,A
	ENDM

	
PCHL	macro
	push	r6
	push	r7
	ret
	endm
	

; store contents of BC
; DPTR = destination
SBCD	macro	addr
	mov	p2,#high addr
	mov	r0,#low addr
	mov	a,r3
	movx	@r0,a
	inc	r0
	mov	a,r2
	movx	@r0,a
	endm
	

; store contents of DE
; DPTR = destination
SDED	macro	addr
	mov	p2,#high addr
	mov	r0,#low addr
	mov	a,r5
	movx	@r0,a
	inc	r0
	mov	a,r4
	movx	@r0,a
	endm

; Store the contents of DPTR to ADDR	
shld0 set 0
SHLD	MACRO	ADDR
	if (shld0=0)
	sjmp	shld2
shld1:	MOV	A,DPH
	MOVX	@R0,A
	INC	R0
	MOV	A,DPL
	MOVX	@R0,A
	ret
shld0 set 1
shld2:
	endif
	MOV	P2,#HIGH ADDR
	MOV	R0,#LOW ADDR
	acall	shld1
	ENDM

; get contents of HL
; DPTR = destination
lhld0 set 0
LHLD	macro	addr
	if (lhld0=0)
	sjmp	lhld2
lhld1:	MOVX	A,@R0
	MOV	dph,A
	INC	R0
	MOVX	a,@R0
	MOV	dpl,A
	ret
lhld0 set 1
lhld2:
	endif
	MOV	P2,#HIGH ADDR
	MOV	R0,#LOW ADDR
	acall	lhld1
	endm

; subtract with carry BC from HL
sbcbc0 set 0
SBCBC	macro
	if(sbcbc0=0)
	sjmp	sbcbc2
sbcbc1:	xch	a,r6
	subb	a,r2
	xch	a,r6
	xch	a,r7
	subb	a,r3
	xch	a,r7
	ret
sbcbc0 set 1
sbcbc2:
	endif
	call	sbcbc1
	endm
	
; subtract with carry DE from HL
sbcde0 set 0
SBCDE	macro
	if(sbcde0=0)
	sjmp	sbcde2
sbcde1:	xch	a,r6
	subb	a,r4
	xch	a,r6
	xch	a,r7
	subb	a,r5
	xch	a,r7
	ret
sbcde0 set 1
sbcde2:
	endif
	call	sbcde1
	endm

; swap DE with HL
xchg0 set 0
XCHG	macro			; checked 950720
	if (xchg0=0)
	sjmp	xchg2
xchg1:	xch	a,r6
	xch	a,r4
	xch	a,r6
	xch	a,r7
	xch	a,r5
	xch	a,r7
	ret
xchg0 set 1
xchg2:
	endif
	acall	xchg1
	endm
	
; swap stack with HL pair, note call return is on stack
xthl0 set 0
XTHL	macro			; checked 950720
	if (xthl0=0)
	sjmp	xthl2
xthl1:	pushreg	r0
	mov	r0,sp
	dec	r0		; past r0 push
	dec	r0
	dec	r0		; past call to here
	xch	a,r7
	xch	a,@r0
	xch	a,r7
	dec	r0		; point to low byte
	xch	a,r6
	xch	a,@r0
	xch	a,r6
	popreg	r0
	ret
xthl0 set 1
xthl2:
	endif
	acall	xthl1
	endm

; 2's compliment HL pair (r6 & r7)
NEGHL0 SET 0
neghl	MACRO			; checked 950720
	IF(NEGHL0=0)
	SJMP	NEGHL2
neghl1:	xch	a,Lreg
	CPL	A
	add	a,#1
	XCH	a,Lreg
	XCH	a,Hreg
	CPL	A
	ADDC	a,#0
	XCH	a,Hreg	
	ret
neghl0 set 1
neghl2:
	endif
	acall	neghl1
	endm
	
inchl	macro
	mov	dph,r7
	mov	dpl,r6
	inc	dptr
	mov	r6,dpl
	mov	r7,dph
	endm

incde0 set 0
incde	macro
	if(incde0=0)
	sjmp	incde2
incde1:	xch	a,r4
	add	a,#1
	xch	a,r4
	xch	a,r5
	addc	a,#0
	xch	a,r5
	ret
incde0 set 1
incde2:
	endif
	call	incde1
	endm
		
PUSHDE	macro
	mov	temp,Ereg
	push	temp
	mov	temp,Dreg
	push	temp
	endm

POPDE	macro
	pop	temp
	mov	Dreg,temp
	pop	temp
	mov	Ereg,temp
	endm
	
PUSHBC	macro
	mov	temp,Creg
	push	temp
	mov	temp,Breg
	push	temp
	endm
	
POPBC	macro
	pop	temp
	mov	Breg,temp
	pop	temp
	mov	Creg,temp
	endm

PUSHHL	macro
	mov	temp,Lreg
	push	temp
	mov	temp,Hreg
	push	temp
	endm
	
POPHL	macro
	pop	temp
	mov	Hreg,temp
	pop	temp
	mov	Lreg,temp
	endm

sfcount	set	0
; shift register right
srright	macro reg,iter,label
	push	acc
	mov	a,reg
	mov	r0,#iter
srr&label:	clr	c
	rrc	a
	djnz	r0,srr&label
	mov	reg,a
	pop	acc
	endm

srr	macro	reg,iter
sfcount	set sfcount + 1
	srright	reg,iter,%sfcount
	endm
	

; shift register left

srleft	macro	reg,iter,label
	push	acc
	mov	a,reg
	mov	r0,#iter
srl&label:
	clr	c
	rlc	a
	djnz	r0,srl&label
	mov	reg,a
	pop	acc
	endm

srl	macro	reg,iter
sfcount	set sfcount + 1
	srleft	reg,iter,%sfcount
	endm

